Package: ncGTW
Type: Package
Title: Alignment of LC-MS Profiles by Neighbor-wise Compound-specific
        Graphical Time Warping with Misalignment Detection
Version: 1.27.0
Author: Chiung-Ting Wu <ctwu@vt.edu>
Maintainer: Chiung-Ting Wu <ctwu@vt.edu>
biocViews: Software, MassSpectrometry, Metabolomics, Alignment
Description: The purpose of ncGTW is to help XCMS for LC-MS data alignment. 
    Currently, ncGTW can detect the misaligned feature groups by XCMS, and the
    user can choose to realign these feature groups by ncGTW or not.
License: GPL-2
Encoding: UTF-8
LazyData: true
RoxygenNote: 6.1.1
LinkingTo: Rcpp
Suggests: BiocStyle, knitr, testthat, rmarkdown
VignetteBuilder: knitr
Depends: methods, BiocParallel, xcms
Imports: Rcpp, grDevices, graphics, stats
BugReports: https://github.com/ChiungTingWu/ncGTW/issues
git_url: https://git.bioconductor.org/packages/ncGTW
git_branch: devel
git_last_commit: 87c9be4
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-07-14
NeedsCompilation: yes
Packaged: 2026-07-14 23:15:40 UTC; biocbuild

ncGTW
=====

The purpose of ncGTW is to detect and fix the bad alignments in the
LC-MS data. Currently, ncGTW is implemented in a R-package as a plug-in
for XCMS. That is, ncGTW can detect the misaligned feature groups from
XCMS and realign them. After that, XCMS can use the realigned data from
XCMS for more accurate grouping and peak-filling.

![Overview of ncGTW](img/XCMS_ncGTW.png)

Installation
------------

You can install the latest version of ncGTW from GitHub by

``` r
devtools::install_github("ChiungTingWu/ncGTW")
```

or from Bioconductor by

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("ncGTW")
```

Algorithm overview
------------------

ncGTW detects the misaligned features with two criterions. First, ncGTW
algorithm estimates the p-value of each feature using higher resolution
alignment result, where the p-value is given by the null hypothesis with
accurate alignment. Second, we identifies all features with sufficiently
small p-values and disjoint sample subsets. Then, ncGTW algorithm
matches the neighboring features to the corresponding features produced
by lower resolution alignment, and consider realigning these features.

![Misalignment detection](img/mis_det.png)

To realign the misaligned features, we proposed a new multiple alignment
method, which is reference free and can incorporate the structure
information in the dataset. There are two core ideas. First, instead of
set a certain reference, ncGTW performs all possible pairwise alignments
between each two sample with the structure information in the dataset.
Second, with all the pairwise alignment as constraints, ncGTW estimates
the warping functions for all sample to a coordinate.

![ncGTW alignment](img/ncGTW.png)

buildMultiParaValidmap <- function(samples, mir, strNum, diaNum, biP=TRUE) {
    if (!(is.logical(mir) && is.logical(biP)))
        stop("mir and biP should be 'TRUE' or 'FALSE'!!!")

    sampNum <- nrow(samples)
    sampLen <- ncol(samples)
    pairMap <- matrix(0, sampNum, sampNum)
    pairNum <- 0

    ## build tst, ref, and pairMap depending on mir & biP
    if (mir && biP){
        tst <- matrix(0, sampNum * (sampNum - 1) / 2, sampLen)
        ref <- tst

        for (jj in seq_len(sampNum)){
            for (ii in seq(jj + 1, sampNum, length=max(0, sampNum - jj))){
                pairNum <- pairNum + 1
                pairMap[ii, jj] <- pairNum
                tst[pairNum, ] <- samples[ii, ]
                ref[pairNum, ] <- samples[jj, ]
            }
        }
    } else{
        tst <- matrix(0, sampNum * (sampNum - 1), sampLen)
        ref <- tst

        for (jj in seq_len(sampNum)){
            for (ii in seq_len(sampNum)){
                if (ii == jj)
                    next
                pairNum <- pairNum + 1
                pairMap[ii, jj] <- pairNum
                tst[pairNum, ] <- samples[ii, ]
                ref[pairNum, ] <- samples[jj, ]
            }
        }
    }

    ## build validMap
    validMap <- matrix(0, pairNum, pairNum)
    #eachMap <- array(0, c(sampNum, sampNum, pairNum))
    for (jj in seq_len(sampNum)){
        for (ii in seq_len(sampNum)){
            if (pairMap[ii, jj] == 0)
                next

            ## check vertical elements
            verEnd <- min(ii + strNum, sampNum)
            for (iii in seq(ii + 1, verEnd, length=max(0, verEnd - ii))){
                if (pairMap[iii, jj] == 0)
                    next

                if (!(mir && !((ii - jj) * (iii - jj) > 0)))
                    validMap[pairMap[iii, jj], pairMap[ii, jj]] <- 1
            }

            ## check horizontal elements
            horEnd <- min(jj + strNum, sampNum)
            for (jjj in seq(jj + 1, horEnd, length=max(0, horEnd - jj))){
                if (pairMap[ii, jjj] == 0)
                    next

                if (!(mir && !((ii - jj) * (ii - jjj) > 0)))
                    validMap[pairMap[ii, jjj], pairMap[ii, jj]] <- 1
            }

            ## check cross elements
            if (!mir){
                if ((ii - jj == 1) && (jj + 2 <= sampNum))
                    validMap[pairMap[ii, jj + 2], pairMap[ii, jj]] <- 1

                if ((jj - ii == 1) && (ii + 2 <= sampNum))
                    validMap[pairMap[ii + 2, jj], pairMap[ii, jj]] <- 1
            }

            ## check diagonal elements
            diaEnd <- min(diaNum, sampNum - max(ii, jj))
            for (kkk in seq(1, diaEnd, length=max(0, diaEnd)))
                validMap[pairMap[ii + kkk, jj + kkk], pairMap[ii, jj] ] <- 1
        }
    }
    return(list(tst=tst, ref=ref, pairMap=pairMap, validMap=validMap))
}


initGtwParam <- function(validMap, noiseVar, maxStp, smo=1, diagonalPenalty=0,
    logt=0, nor=2) {

    tmpEast <- validMap * 1
    tmpSouth <- validMap * 1
    smoMap <- array(c(tmpEast, tmpSouth) * smo, c(dim(validMap), 2))

    s2 <- noiseVar  # noise variance map
    epAdd <- 0
    epMul <- 1
    winSize <- max(maxStp, 1)
    offDiagonalPenalty <- 0
    inf0 <- 1e300
    partialMatchingCost <- (0:winSize) * 1e8

    return(list(smoBase=smo, diagonalPenalty=diagonalPenalty, logt=logt,
        nor=nor, smoMap=smoMap, s2=s2, epAdd=epAdd, epMul=epMul,
        winSize=winSize, offDiagonalPenalty=offDiagonalPenalty, inf0=inf0,
        partialMatchingCost=partialMatchingCost))
}


getDistMat <- function(ref, tst, refP, tstP, biP, weiP, nor){

    nTps <- length(ref)
    refM <- replicate(nTps, ref)
    tstM <- t(replicate(nTps, tst))

    refPM <- replicate(nTps, refP)
    tstPM <- replicate(nTps, tstP)

    d0 <- (abs(refM - tstM)) ^ nor
    if ((nor != 1) && ((nor != 2)))
        warning('norm is not an integer!')

    if (sum(is.na(d0))){
        warning('There are some NA in d0.')
        d0[is.na(d0)] <- 0
    }

    stopifnot(is.logical(biP), !is.na(biP))
    if (weiP == -1) stopifnot(biP)
    switch(as.character(weiP),
        "0"={ dp <- d0 },
        "-1"={
            a0 <- (tstPM + refPM) / 2
            g0 <- (tstPM * refPM) ^ (0.5)
            a1 <- (a0 + g0) / 2
            g1 <- (a0 * g0) ^ (0.5)
            a2 <- (a1 + g1) / 2
            g2 <- (a1 * g1) ^ (0.5)
            a3 <- (a2 + g2) / 2
            dp <- d0 / a3
        },
        dp <- ifelse(biP, list((d0 / ((tstPM * refPM)^weiP))),
            list(d0 / (tstPM ^ weiP)))[[1]]
    )

    dp[is.infinite(dp)] <- 10 ^ 300
    dp[is.infinite(dp)] <- 10 ^ 300

    dM <- array(0, c(dim(d0), 2))
    dM[, , 1] <- d0
    dM[, , 2] <- dp
    return(dM)
}

buildGTWgraph <- function(ref, tst, validMap, param, mu=0, sigma=1, biP=TRUE,
    weiP=0, type=0, path=NA, pairMap=NA) {

    ## type=0: typical GTW graph
    ## type=1: ncGTW graph
    ## type=2: merge GTW graph

    smoMap <- param$smoMap
    smoBase <- param$smoBase
    s2 <- param$s2
    epAdd <- param$epAdd
    epMul <- param$epMul
    win <- param$winSize
    ofstPen <- param$offDiagonalPenalty
    diagonalPenalty <- param$diagonalPenalty
    capRev <- param$inf0
    pmCost <- param$partialMatchingCost

    logt <- param$logt
    nor <- param$nor

    if (sum(abs(diag(validMap))) != 0)
        stop('The diagonal terms of validMap should all be zero.')

    nPix <- dim(tst)[1]
    nTps <- dim(tst)[2]

    if (length(mu) != length(sigma))
        stop('The number of mu, sigma and pairs should be the same.')
    if ((length(mu) != 1) && (length(mu) != nPix))
        stop('The number of mu should be 1 or number of pairs.')

    if (logt == 0){
        refP <- 1 - pnorm(log(ref+1), mu, sigma)
        tstP <- 1 - pnorm(log(tst+1), mu, sigma)
    } else{
        refP <- 1 - pnorm(ref, mu, sigma)
        tstP <- 1 - pnorm(tst, mu, sigma)
    }


    distMask <- matrix(0, nTps, nTps)
    diagMask <- matrix(0, nTps, nTps)
    for (ii in seq_len(nTps)){
        diagMask[ii,ii] <- diagonalPenalty
        for (jj in seq_len(nTps))
            distMask[ii, jj] <- ofstPen * (abs(ii - jj) > 0)
    }

    scl0 <- 1e8  # larger than time points
    #  validMapIdx <- validMap * 0
    #  validMapIdx[validMap > 0] <- 1 : sum(validMap > 0)

    nNeibPair <- (sum(lower.tri(validMap) * validMap != 0))

    if (length(s2) == 1)
        s2 <- matrix(s2, nPix, 1)
    s2x <- s2[s2 > 0]
    s2xMean <- mean(s2x, na.rm=TRUE)
    pmCost <- pmCost / 2 / s2xMean

    ## template using coordinate
    edgeInfo  <- buildPairTemplate(nTps,win,pmCost)
    pEdge     <- (edgeInfo$pEdge)
    dEdge     <- (edgeInfo$dEdge)
    weightPos <- (edgeInfo$cPos)
    weightVal <- (edgeInfo$cVal)
    st01      <- (edgeInfo$st01)
    eType     <- (edgeInfo$eType)


    ## -- direction penalty, additive or multiplicative
    weightVal[eType == 2] <- weightVal[eType == 2] + epAdd
    weightValMul <- weightVal * 0 + 1
    weightValMul[eType == 2] <- epMul

    ## re-code coordinates to single number
    tmp <- dEdge * 4
    tmp <- cbind(tmp[ , 1] * scl0 + tmp[ , 2], tmp[ , 3] * scl0 + tmp[ , 4])
    ia <- which(!(duplicated(as.vector(tmp))))
    tmpUniq <- tmp[ia]
    tmpUniqSort <- sort(tmpUniq, index.return = TRUE)
    tmpUniq <- tmpUniqSort$x
    ia <- ia[tmpUniqSort$ix]

    nNodeGrid <- length(tmpUniq) - 2
    srcNode <- nNodeGrid * nPix + 1
    sinkNode <- nNodeGrid * nPix + 2

    mapObj <- as.list(c(sinkNode, seq_len(nNodeGrid), srcNode))
    names(mapObj) <- tmpUniq

    dEdgeInt <- apply(tmp, c(1, 2), function(x) mapObj[[as.character(x)]])
    dEdge1 <- rbind(dEdge[ ,c(1, 2)], dEdge[ , 3:4])
    nodePos <- dEdge1[ia[2:(length(ia) - 1)], ]

    ## split the edge matrix to src/sink and within grid
    ## nodes connected with src or sink
    d1 <- dEdgeInt[ , 1]
    d2 <- dEdgeInt[ , 2]
    idxSrc <- which(d1 == srcNode)
    idxSink <- which(d2 == sinkNode)

    ## extra weight for ss edges
    ssTmpWt <- matrix(0, nNodeGrid, 2)
    ssTmpWt[d2[idxSrc], 1]  <- weightVal[idxSrc]
    ssTmpWt[d1[idxSink], 2] <- weightVal[idxSink]

    ## weight from curve distance for ss edges
    wtPos1 <- cbind(weightPos[,1] + (weightPos[,2] - 1) * nTps, eType)
    ssTmpPos <- matrix(0, nNodeGrid, 2) + nTps * nTps + 1
    ssTmpPos[d2[idxSrc],  1] <- wtPos1[idxSrc,  1]
    ssTmpPos[d1[idxSink], 2] <- wtPos1[idxSink, 1]

    ## edges between nodes (except src and sink)
    idxNotSS <- d1 != srcNode & d2 != sinkNode
    eeTmp <- cbind(dEdgeInt[idxNotSS, ], wtPos1[idxNotSS, ],
        weightVal[idxNotSS], weightValMul[idxNotSS])
    nEdgeGrid <- dim(eeTmp)[1]

    ## output, for label and path mapping
    pEdgeSS <- pEdge[!idxNotSS, ]
    pEdgeEE <- pEdge[idxNotSS, ]
    dEdgeIntSS <- dEdgeInt[!idxNotSS, ]
    dEdgeIntEE <- dEdgeInt[idxNotSS, ]

    ## edges for within pairs using integer
    if (type == 2){
        ssPair <- matrix(0, nNodeGrid, 2)
        eePair <- matrix(0, nEdgeGrid, 4)
    } else if (smoBase > 0 && type == 0){
        ssPair <- matrix(0, nPix * nNodeGrid, 2)
        eePair <- matrix(0, nPix * nEdgeGrid + nNodeGrid * nNeibPair, 4)
    } else{
        ssPair <- matrix(0, nPix * nNodeGrid, 2)
        eePair <- matrix(0, nPix * nEdgeGrid, 4)
    }
    eePair[ , 4] <- capRev

    for (ii in seq_len(nPix)){
        # s2x <- s2[ii]
        if (type == 2){
            eeOfst <- 0
            ssOfst <- 0
        } else{
            eeOfst <- (ii - 1) * nEdgeGrid
            ssOfst <- (ii - 1) * nNodeGrid
        }

        # position (1,T+1) means not using distance matrix
        if (type == 1){
            d0 <- matrix(0, nTps, nTps)
            dp <- matrix(1, nTps, nTps)
            # d0 <- d0 / s2x + distMask
            # dp <- dp / s2x + distMask
        } else{
            if (dim(ref)[1] == 1){
                dM <-
                    getDistMat(ref, tst[ii, ], refP, tstP[ii, ], biP, weiP, nor)
            } else {
                dM <-
                    getDistMat(ref[ii, ], tst[ii, ], refP[ii, ], tstP[ii, ],
                        biP, weiP, nor)
            }
            d0 <- dM[ , , 1, drop=TRUE]
            dp <- dM[ , , 2, drop=TRUE]
            # d0 <- d0 / s2x + distMask + diagMask
            # dp <- dp / s2x + distMask
        }

        d0ext <- cbind(d0, matrix(0, dim(d0)[1], 1))
        dpext <- cbind(dp, matrix(0, dim(dp)[1], 1))
        # edges from src and to sink
        ssPair[(ssOfst + 1):(ssOfst + nNodeGrid), ] <-
            ssPair[(ssOfst + 1):(ssOfst + nNodeGrid), ] +
            matrix(d0ext[as.vector(ssTmpPos)] + as.vector(ssTmpWt), nNodeGrid,2)
        # edges between nodes
        if (type == 1){
            tmp <- matrix(0, dim(eeTmp)[1], 3)
            tmp[eeTmp[ , 4] == 2, ] <-
                cbind(eeTmp[eeTmp[ , 4] == 2, c(1,2)] + ssOfst,
                    (dpext[eeTmp[eeTmp[ , 4] == 2, 3]] +
                        eeTmp[eeTmp[ , 4] == 2, 5]) * eeTmp[eeTmp[, 4] == 2, 6])
            tmp[eeTmp[ , 4] != 2, ] <-
                cbind(eeTmp[eeTmp[ , 4] != 2, c(1,2)] + ssOfst,
                    (d0ext[eeTmp[eeTmp[ ,4] != 2, 3]] +
                        eeTmp[eeTmp[ , 4] != 2, 5]) * eeTmp[eeTmp[ ,4] != 2, 6])

        } else{
            tmp <- cbind(eeTmp[, c(1,2)] + ssOfst,
                (dpext[eeTmp[, 3]] + eeTmp[, 5]) * eeTmp[, 6])
        }

        if (type == 2){
            eePair[ ,c(1,2)] <- tmp[ ,c(1,2)]
            eePair[ ,3] <- eePair[ ,3] + tmp[ ,3]
        } else{
            eePair[(eeOfst + 1):(eeOfst + nEdgeGrid), c(1,2,3)] <- tmp
        }
    }

    ss <- ssPair
    ee <- eePair

    gtwInfo <-
        list(ss = ss, ee = ee, nodePos = nodePos, weightPos = weightPos,
            weightVal = weightVal, pEdge = pEdge, pEdgeSS = pEdgeSS,
            pEdgeEE = pEdgeEE, dEdge = dEdge, dEdgeInt = dEdgeInt,
            dEdgeIntSS = dEdgeIntSS, dEdgeIntEE = dEdgeIntEE,
            validMap = validMap, srcSinkPos = st01, nTps = nTps,
            nPix = nPix, nNodeGrid = nNodeGrid,
            nNodes = nNodeGrid * nPix + 2, nEdgeGrid = nEdgeGrid,
            ssTmpPos = ssTmpPos)

    if (smoBase == 0 || type == 2)
        return(gtwInfo)

    ## edges for between pairs
    if (type == 0){
        nn <- 0
        for (jj in seq_len(nPix)){
            for (ii in seq(jj + 1, nPix, length = max(0, nPix - jj))){
                if (validMap[ii, jj] != 1)
                    next
                idx1 <- nn + 1
                idx2 <- nn + nNodeGrid
                eePair[(idx1:idx2) + nPix * nEdgeGrid, 1] <- (jj - 1) *
                    nNodeGrid + (seq_len(nNodeGrid))
                eePair[(idx1:idx2) + nPix * nEdgeGrid, 2] <- (ii - 1) *
                    nNodeGrid + (seq_len(nNodeGrid))
                smo0 <- smoMap[ii, jj, 2]
                # smo0 = min(smoMap(ii,jj),smoMap(ii+1,jj))
                eePair[(idx1:idx2) + nPix * nEdgeGrid, 3:4] <- smo0
                nn <- nn + nNodeGrid
            }
        }
        gtwInfo$ee <- eePair
        return(gtwInfo)
    }


    ## type == 1
    ia <- which(!(duplicated(as.vector(dEdgeInt))))
    tdp <- dEdgeInt[ia]
    tdpSort <- sort(tdp, index.return=TRUE)
    tdp <- tdpSort$x
    ia <- ia[tdpSort$ix]

    ll <- dim(dEdgeInt)[1]
    tdP2 <- cbind(dEdge[trunc(ia / ll) * ll + ia],
        dEdge[trunc(ia / ll + 1) * ll + ia])
    GridMap <- matrix(0, 2 * nTps, 2 * nTps)

    for (ii in seq_len(dim(tdP2)[1] - 2)){
        if (round(tdP2[ii, 1] / 0.5) != tdP2[ii, 1] / 0.5){
            if (round(tdP2[ii, 2] / 0.5) != tdP2[ii, 2] / 0.5){
                GridMap[tdP2[ii, 1] * 2 - 0.5, tdP2[ii, 2] * 2 - 0.5] <- ii
            }
        }
    }
    eeSpa <- matrix(0, nTps * nTps * 4 * nNeibPair, 4)
    outIdx <- matrix(TRUE, nTps * nTps * 4 * nNeibPair, 1)

    nn <- 0
    for (jj in seq_len(nPix)){
        for (ii in seq(jj + 1, nPix, length = max(0, nPix - jj))){
            if (validMap[ii, jj] != 1)
                next
            nowIdx <- jj
            tgtIdx <- ii
            idx1 <- nn + 1
            idx2 <- nn + nTps * nTps * 4

            tmpPath <- path[[pairMap[ii, jj]]]
            gtwEdge <- matrix(0, nTps * nTps * 4, 3)
            gtwEdgePP <- matrix(0, nTps * nTps * 4, 2)
            # outIdxt = zeros(nTps*nTps*4, 1)
            gtwEdge[ ,3] <- 1
            for (kk in seq_len(dim(tmpPath)[1])){
                if ((tmpPath[kk, 1] == 0 || tmpPath[kk, 2] == 0))
                    next
                tmpSp <- nTps * 4 * (tmpPath[kk, 2] - 1)

                gtwEdge[(tmpSp + 1):(tmpSp + nTps * 2), c(1, 2)] <-
                    GridMap[ , 2 * tmpPath[kk, c(1, 2)] - 1]
                gtwEdge[(tmpSp + nTps * 2 + 1):(tmpSp + nTps * 4), c(1, 2)] <-
                    GridMap[ , 2 * tmpPath[kk, c(1, 2)]]
                gtwEdgePP[(tmpSp + 1):(tmpSp + nTps * 4), c(1, 2)] <-
                    tmpPath[kk, c(1, 2)]
            }
            outIdxt <- gtwEdge[ , 1] != 0 & gtwEdge[ , 2] != 0

            tempV1 <- log(tst[nowIdx, gtwEdgePP[outIdxt, 1]] + 1)
            tempV2 <- log(tst[tgtIdx, gtwEdgePP[outIdxt, 2]] + 1)
            tempP1 <- (1 - pnorm(tempV1, mu[nowIdx], sigma[nowIdx])) ^ weiP
            tempP2 <- (1 - pnorm(tempV2, mu[tgtIdx], sigma[tgtIdx])) ^ weiP
            gtwEdge[outIdxt, 3] <- min(tempP1, tempP2)

            gtwEdge[gtwEdge[ , 3] == 0, 3] <- 1 / capRev

            outIdx[idx1:idx2] <- outIdxt
            eeSpa[idx1:idx2, 1] <- (nowIdx - 1) * nNodeGrid + gtwEdge[ , 1]
            eeSpa[idx1:idx2, 2] <- (tgtIdx - 1) * nNodeGrid + gtwEdge[ , 2]
            smo0 <- smoMap[ii, jj, 1]
            eeSpa[idx1:idx2, 3] <- smo0 / gtwEdge[ , 3]
            eeSpa[idx1:idx2, 4] <- smo0 / gtwEdge[ , 3]
            #             eeSpa(idx1:idx2,3) = smo0
            #             eeSpa(idx1:idx2,4) = smo0
            nn <- nn + nTps * nTps * 4
        }
    }
    eeSpa <- eeSpa[outIdx, ]
    tmpSort <- sort(eeSpa[ , 2], index.return = TRUE)
    eeSpa <- eeSpa[tmpSort$ix, ]
    ee <- rbind(eePair, eeSpa)

    gtwInfo$ee <- ee
    return(gtwInfo)
}

buildPairTemplate <- function(nTps, win, pmCost) {
    # Get a template of graphs for single pair using coordinates
    # Get both primal edges and dual edges in coordinates
    # Use extra src and sink node to allow partial matching
    # Specify partial matching cost by pmCost of size 1 x winSize
    # weightPos gives pixel dependent portion of the weight based on position
    # in the distance matrix
    # If take position (1,T+1), it means not using the distance matrix
    # weightVal gives prespecified weight independent of pixel, zero means not
    # using Edge types (eType).
    # 1: diagonal/from grid to sink
    # 2: horizontal or vertical
    # 3: from src to grid
    #
    # !! this could introduce bias, need better normalization
    #
    # Inf means maximum value (usually infinite capacity)
    # 0 means there is nothing
    #
    # Pairs in the form (ref,tst). Weight position also (ref,tst)
    # For coordinates, actually this means ref in x axis and tst in y axis

    ## setup

    if (win <= 1)
        stop("winSize should be integer larger than 1\n")

    s0 <- c(0,0)
    t0 <- c(nTps + 1, nTps + 1)
    s1 <- c(nTps + 1, 0)
    t1 <- c(0, nTps + 1)
    st01 <- c(s0, t0, s1, t1)

    # diagnal, sub diagonals, extra edges to s and t, vertical and horizontal
    # edges all in two directions, the reverse is infinite, but we ONLY build
    # finite portion here
    nEdges <- nTps - 1 + (nTps - 2 + nTps - win) * (win - 1) +
        2 * (2 * win - 1) + 2 * (nTps - 1 + nTps - win + 1) * (win - 1)

    # primal and dual edges as well as weights in coordinate form
    # node1 -> node2: (x,y) for node1, (x,y) for node 2
    # (x,y) for weight matrix position, (1,T+1) means none exist position
    pEdge <- matrix(0, nEdges, 4)
    dEdge <- matrix(0, nEdges, 4)
    cPos <- cbind(matrix(1, nEdges, 1), matrix(1, nEdges, 1) * (nTps + 1))
    cVal <- matrix(0, nEdges, 1)
    eType <- matrix(0, nEdges,1)

    ## assign edges
    # loop through all nodes in primal graph, get edges to the right, top or
    # top-right save each edge, and the corresponding dual edge, as well as the
    #  position in the weighting matrix edges outside the window is not included

    # from s to nodes
    pEdge[1, ] <- c(s0,1,1)
    dEdge[1, ] <- c(1.5,0.5,0.5,1.5)
    nn <- 2
    for (w in 2:win){
        pEdge[nn, ] <- c(s0, 1, w)  # close to top left
        pEdge[nn + 1, ] <- c(s0, w, 1)  # close to bottom right
        if (w == win){
            dEdge[nn, ] <- c(0.5, w - 0.5, t1)
            dEdge[nn + 1, ] <- c(s1, w - 0.5, 0.5)
        } else {
            dEdge[nn, ] <- c(0.5, w - 0.5, 0.5, w + 0.5)
            dEdge[nn + 1, ] <- c(w + 0.5, 0.5, w - 0.5, 0.5)
        }
        eType[nn:(nn + 1)] <- 3
        cVal[nn] <- pmCost[w]
        cVal[nn + 1] <- pmCost[w]
        nn <- nn + 2
    }

    # within grid
    for (x0 in seq_len(nTps)){  # ref
        for (y0 in seq_len(nTps)){  # tst
            if (x0 == nTps && y0 == nTps)
                next

            if (y0 < (x0 - win + 1) || y0 > (x0 + win - 1))
                next

            x <- x0
            y <- y0 + 1  # top

            if (y >= (x - win + 1) && y <= (x + win - 1) && x <= nTps &&
                y <= nTps){
                pEdge[nn, ] <- c(x0, y0, x, y)
                cPos[nn, ] <- c(x0, y0)
                if (x0 == 1){
                    dEdge[nn, ] <- c(x0 + 0.25, y0 + 0.75, 0.5, y0 + 0.5)
                } else if (x0 == nTps){
                    dEdge[nn, ] <- c(nTps + 0.5, y0 + 0.5, x0 - 0.25, y0 + 0.25)
                } else{
                    dEdge[nn, ] <- c(x0 + 0.25, y0 + 0.75, x0 - 0.25, y0 + 0.25)
                }
                eType[nn] <- 2
                nn <- nn + 1
            }

            x <- x0 + 1
            y <- y0  # right

            if (y >= (x - win + 1) && y <= (x + win - 1) && x <= nTps &&
                y <= nTps){
                pEdge[nn, ] <- c(x0, y0, x, y)
                cPos[nn, ] <- c(x0, y0)
                if (y0 == 1){
                    dEdge[nn, ] <- c(x0 + 0.5, 0.5, x0 + 0.75, y0 + 0.25)
                } else if (y0 == nTps){
                    dEdge[nn, ] <- c(x0 + 0.25, y0 - 0.25, x0 + 0.5, nTps + 0.5)
                } else{
                    dEdge[nn, ] <- c(x0 + 0.25, y0 - 0.25, x0 + 0.75, y0 + 0.25)
                }
                eType[nn] <- 2
                nn <- nn + 1
            }

            x <- x0 + 1
            y <- y0 + 1   # topright (diagonal)

            if (y >= (x - win + 1) && y <= (x + win - 1) && x0 < nTps &&
                y0 < nTps){
                pEdge[nn, ] <- c(x0, y0, x, y)
                cPos[nn, ] <- c(x0, y0)
                if (y == (x + win - 1)){
                    dEdge[nn, ] <- c(x0 + 0.75, y0 + 0.25, t1)
                } else if (y == (x - win + 1)){
                    dEdge[nn, ] <- c(s1, x0 + 0.25, y0 + 0.75)
                } else{
                    dEdge[nn, ] <- c(x0 + 0.75, y0 + 0.25, x0 + 0.25, y0 + 0.75)
                }
                eType[nn] <- 1
                nn <- nn + 1
            }
        }
    }
    # from nodes to t
    pEdge[nn, ] <- c(nTps, nTps, t0)
    dEdge[nn, ] <- c(nTps + 0.5, nTps - 0.5, nTps - 0.5, nTps + 0.5)
    cPos[nn, ] <- c(nTps, nTps)
    nn <- nn + 1
    for (w in 2:win){
        pEdge[nn, ] <- c(nTps - w + 1, nTps, t0)  # close to top left
        pEdge[nn + 1, ] <- c(nTps, nTps - w + 1, t0)  # close to bottom right
        if (w == win){
            dEdge[nn, ] <- c(nTps + 1 - w + 0.5, nTps + 0.5, t1)
            dEdge[nn + 1, ] <- c(s1, nTps + 0.5, nTps + 1 - w + 0.5)
        } else {
            dEdge[nn, ] <- c(nTps + 1 - w + 0.5, nTps + 0.5, nTps + 1 - w - 0.5,
                nTps + 0.5)
            dEdge[nn + 1, ] <- c(nTps + 0.5, nTps + 1 - w - 0.5, nTps + 0.5,
                nTps + 1 - w + 0.5)
        }
        cPos[nn, ] <- c(nTps - w + 1, nTps)
        cPos[nn + 1, ] <- c(nTps, nTps - w + 1)
        cVal[nn] <- pmCost[w]
        cVal[nn + 1] <- pmCost[w]
        eType[nn : (nn + 1)] <- 1
        nn <- nn + 2
    }

    return(list(pEdge = pEdge, dEdge = dEdge, cPos = cPos, cVal = cVal,
                st01 = st01, eType = eType))
}

#' Detect misaligned peak groups in xcmsSet object of XCMS
#'
#' This function detects the misaligned peak groups with two
#' \code{\link[xcms]{xcmsSet-class}} object with two different values of
#' \code{bw} parameter in \code{\link[xcms:group.density]{group}}.
#' @param xcmsLargeWin A \code{\link[xcms]{xcmsSet-class}} object with a larger
#'   \code{bw}, usually the maximum expected retension time drift.
#' @param xcmsSmallWin A \code{\link[xcms]{xcmsSet-class}} object with a smaller
#'   \code{bw}, usually the resolution of the retension time.
#' @param ppm Should be set as same as the one when performing the peak
#'   detection function in \code{xcms}.
#' @param qThre The threshould of the p-value after multiple test correction.
#'   The default is 0.05.
#' @param overlapRate The threshould of the overlapping rate of sample index.
#'   The default is 0.
#' @param maxRtWin The threshould of the maximum retension time range. This is
#'   for filtering out some bad groups. The default is 50 (seconds).
#' @details This function includes two major steps to determine a peak group is
#' misaligned or not. The first step calculates the p-value of each peak group
#' in xcmsSmallWin, and find the corresponding peak group in xcmsLargeWin. The
#' second step is to find the exclusive peak groups (the groups with no
#' overlapping samples) with adjsted p-values smaller than \code{qThre}.
#' @return A matrix with all detected misaligned peak groups. The column names
#' are the same as \code{group} slot in \code{\link[xcms]{xcmsSet-class}}, but
#' the first column is the group index.
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#' xcmsSmallWin <- xcmsExamples$xcmsSmallWin
#' ppm <- xcmsExamples$ppm
#'
#' # detect misaligned features
#' excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
#' @export

misalignDetect <- function(xcmsLargeWin, xcmsSmallWin, ppm, qThre=0.05,
    overlapRate=0, maxRtWin=50){
    groupInfo <- splitGroupPval(xcmsLargeWin, xcmsSmallWin)
    excluInfo <- exclusiveGroups(groupInfo, ppm, qThre, overlapRate)
    excluGroups <- excluInfo$excluGroups

    rtWin <-  excluGroups[ , 'rtmax'] - excluGroups[ , 'rtmin']
    return(excluGroups[rtWin < maxRtWin, , drop = FALSE])
}




splitGroupPval <- function(xcmsLargeWin, xcmsSmallWin) {

    largeWinGroupidx <- xcmsLargeWin@groupidx
    smallWinGroupidx <- xcmsSmallWin@groupidx

    groupLargeSmallIndex <- matrix(0, nrow(xcmsLargeWin@peaks), 2)

    for (i in seq_along(largeWinGroupidx)) {
        for (j in seq_along(largeWinGroupidx[[i]])){
            groupLargeSmallIndex[largeWinGroupidx[[i]][j], 1] <- i
        }
    }
    for (i in seq_along(smallWinGroupidx)) {
        for (j in seq_along(smallWinGroupidx[[i]])){
            groupLargeSmallIndex[smallWinGroupidx[[i]][j], 2] <- i
        }
    }

    matchTwoGroup <- matrix(0, length(largeWinGroupidx),
                            length(smallWinGroupidx))
    for (n in seq_len(nrow(xcmsLargeWin@peaks))) {
        if (groupLargeSmallIndex[n,1] != 0 &
            groupLargeSmallIndex[n,2] != 0) {
            matchTwoGroup[groupLargeSmallIndex[n,1],
            groupLargeSmallIndex[n,2]] =
            matchTwoGroup[groupLargeSmallIndex[n,1],
            groupLargeSmallIndex[n,2]] + 1
        }
    }

    matchGroupCount <- apply(matchTwoGroup, 1, function(x) sum(x != 0))
    matchGroupIdx <- apply(matchTwoGroup, 1, function(x) which(x != 0))

    match2More <- which(matchGroupCount>1)

    sampleNum <- length(xcmsLargeWin@filepaths)


    largeWinSampleidx <- vector('list', length(largeWinGroupidx))
    for (n in seq_along(largeWinGroupidx)){
        largeWinSampleidx[[n]] <-
            xcmsLargeWin@peaks[largeWinGroupidx[[n]], 'sample']
    }

    smallWinSampleidx <- vector('list', length(smallWinGroupidx))
    for (n in seq_along(smallWinGroupidx)){
        smallWinSampleidx[[n]] <-
            xcmsSmallWin@peaks[smallWinGroupidx[[n]], 'sample']
    }

    pvalues <- vector('integer', length(smallWinGroupidx)) - 1
    pvalueIdx <- vector('integer', 0)

    for (n in seq_along(smallWinGroupidx)){
        if (sum(matchTwoGroup[,n]) > 0){
            pvalues[n] <- peakGroupPvalOrder(smallWinSampleidx[[n]], sampleNum)
            pvalueIdx <- c(pvalueIdx, n)
        }
    }


    tempPval <- pvalues[pvalueIdx]
    tempQval <- p.adjust(tempPval, 'fdr')
    qvalues <- vector('integer', length(smallWinGroupidx)) + 1

    qvalues[pvalueIdx] <- tempQval

    pqValues <- matrix(0, length(largeWinGroupidx), 2)

    for (n in seq_along(largeWinGroupidx)){
        tempIdx <- matchGroupIdx[[n]]
        if (length(tempIdx) == 0){
            pqValues[n,c(1,2)] <- 2
        } else{
            pqValues[n, 1] <- min(pvalues[tempIdx])
            pqValues[n, 2] <- min(qvalues[tempIdx])
        }
    }
    groupInfo <-
        list(largeWinGroups = xcmsLargeWin@groups,
            smallWinGroups = xcmsSmallWin@groups,
            largeWinGroupidx = largeWinGroupidx,
            smallWinGroupidx = smallWinGroupidx,
            largeWinSampleidx = largeWinSampleidx,
            smallWinSampleidx = smallWinSampleidx,
            matchGroupIdx = matchGroupIdx, pvalueIdx = pvalueIdx,
            pvalues = pvalues, qvalues = qvalues, pqValues = pqValues)

    return(groupInfo)
}


exclusiveGroups <- function(groupInfo, ppm, qThre, overlapRate){
    excluGroupsNum <- vector('integer', length(groupInfo$largeWinGroupidx))
    excluLargeSmall <- vector('list', length(groupInfo$largeWinGroupidx))
    excluPval <- vector('list', length(groupInfo$largeWinGroupidx))

    groups <- groupInfo$smallWinGroups

    for (n in seq_along(groupInfo$largeWinGroupidx)){
        tempInd <- groupInfo$matchGroupIdx[[n]]
        tempInd <- tempInd[groupInfo$qvalues[tempInd] < qThre]

        if (length(tempInd) > 1){
            tempGroups <- groupInfo$smallWinSampleidx[tempInd]
            tempGroupNum <- length(tempGroups)

            for (i in seq_len(tempGroupNum - 1)){
                for (j in seq.int(i+1, tempGroupNum)){
                    if (length(intersect(tempGroups[[i]],
                        tempGroups[[j]])) /
                        max(length(tempGroups[[i]]),
                            length(tempGroups[[j]]))<= overlapRate){
                        if (abs(groups[tempInd[i], 'mzmed'] -
                                groups[tempInd[j], 'mzmed']) /
                            min(groups[tempInd[i], 'mzmed'],
                                groups[tempInd[j], 'mzmed']) *
                            1000000 < ppm){
                            excluGroupsNum[n] <- excluGroupsNum[n] + 1
                            ttest <- t.test(tempGroups[[i]], tempGroups[[j]])
                            excluPval[[n]] <- c(excluPval[[n]], ttest$p.value)
                            excluLargeSmall[[n]] <-
                                cbind(excluLargeSmall[[n]],
                                rbind(tempInd[i], tempInd[j]))


                        }

                    }
                }
            }
        }
    }
    excluGroups <-
        cbind(which(excluGroupsNum != 0),
            groupInfo$largeWinGroups[which(excluGroupsNum != 0), ,drop=FALSE])
    colnames(excluGroups)[1] <- 'index'

    excluInfo <-
        list(excluGroups = excluGroups, excluPval = excluPval,
            excluLargeSmall = excluLargeSmall)

    return(excluInfo)
}
















peakGroupPvalOrder <- function(peakIdx, sampleNum) {
    peakIdx <- unique(sort(peakIdx))
    peakIdxDif <- peakIdx[length(peakIdx)] - peakIdx[1]

    hypValue <- 0
    for (n in (length(peakIdx)-1) : peakIdxDif)
    {
        hypValue <- hypValue + (sampleNum - n) * choose(n-1, length(peakIdx)-2)
    }
    pVal <- hypValue / choose(sampleNum, length(peakIdx))
    if (length(peakIdx) == 1 | is.nan(pVal)){
        pVal <- 1
    }
    return(pVal)
}


peakGroupPval <- function(peakIdx, sampleNum, testNum) {
    peakIdx <- unique(sort(peakIdx))
    peakIdxDif <- peakIdx[seq.int(2, length(peakIdx))] -
        peakIdx[seq_len(length(peakIdx) - 1)]
    testVal <- mean(peakIdxDif)

    peakNum <- length(peakIdx)
    nullVal <- vector('numeric', testNum)

    for (n in seq_len(testNum)){
        nullIdx <- sort(sample(seq_len(sampleNum), peakNum))
        nullIdxDif <- nullIdx[seq.int(2, length(nullIdx))] -
            nullIdx[seq_len(length(nullIdx) - 1)]
        nullVal[n] <- mean(nullIdxDif)
    }

    pVal <- sum(nullVal <= testVal) / length(nullVal)

    if (length(peakIdx) == 1){
        pVal <- 1
    }
    return(pVal)
}

context("Valid ncGTW")
library(xcms)

test_that("misalignDetect detects misaligned features", {
    data('xcmsExamples')
    xcmsLargeWin <- xcmsExamples$xcmsLargeWin
    xcmsSmallWin <- xcmsExamples$xcmsSmallWin
    ppm <- xcmsExamples$ppm

    # detect misaligned features
    expect_equal(nrow(misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)), 2)
})

test_that("loadProfile loads all sample profiles, ncGTWalign realign the
          misaligned feature, and adjustRT produces the new warping functions",
          {
    data('xcmsExamples')
    xcmsLargeWin <- xcmsExamples$xcmsLargeWin
    xcmsSmallWin <- xcmsExamples$xcmsSmallWin
    ppm <- xcmsExamples$ppm

    # detect misaligned features
    excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)

    # obtain the paths of the sample files
    filepath <- system.file("extdata", package = "ncGTW")
    file <- list.files(filepath, pattern="mzxml", full.names=TRUE)

    tempInd <- matrix(0, length(file), 1)
    for (n in seq_along(file)){
        tempCha <- file[n]
        tempLen <- nchar(tempCha)
        tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
                                        tempLen - 6))
    }
    # sort the paths by data acquisition order
    file <- file[sort.int(tempInd, index.return = TRUE)$ix]

    # load the sample profiles
    ncGTWinputs <- loadProfile(file, excluGroups)

    expect_equal(length(ncGTWinputs), 2)
    expect_equal(nrow(ncGTWinputs[[1]]@profiles), length(file))
    expect_equal(nrow(ncGTWinputs[[2]]@profiles), length(file))

    # initialize the parameters of ncGTW alignment with default
    ncGTWparam <- new("ncGTWparam")

    # run ncGTW alignment
    ncGTWoutputs <- ncGTWalign(ncGTWinputs[[1]], xcmsLargeWin, 5,
                               ncGTWparam = ncGTWparam)
    expect_equal(length(ncGTWoutputs@ncGTWpath), length(file))

    # adjust RT with the realignment results from ncGTW
    ncGTWres <- xcmsLargeWin

    adjustRes <- adjustRT(ncGTWres, ncGTWinputs[[1]], ncGTWoutputs, ppm)

    expect_equal(nrow(adjustRes@ncGTWpeaks), nrow(peaks(xcmsLargeWin)))
    expect_equal(length(adjustRes@rtncGTW), length(file))
})

#' Examples of xcmsSet for inputs of ncGTW
#'
#' These two \code{\link[xcms]{xcmsSet-class}} objects are created from the
#' example dataset attached in this package (in extdata folder) with XCMS
#' package. They are examples for inputs of \code{\link{misalignDetect}}.
#'
#' The example dataset contains 20 samples picked from an in-house LC-MS
#' dataset. The user can replicate the two \code{\link[xcms]{xcmsSet-class}}
#' objects with \code{\link[xcms]{xcmsSet}}, \code{\link[xcms]{retcor-methods}},
#' and \code{\link[xcms]{group-methods}}. For details, please refer to the user
#' manual.
#' @docType data
#' @name xcmsExamples
#' @usage data(xcmsExamples)
#' @format A list with two \code{\link[xcms]{xcmsSet-class}} objects and one
#'   \code{ppm} parameter.
NULL

#' Compute average pairwise correlation and overlapping area
#'
#' This function computes average pairwise correlation and overlapping area of
#' each sample pair.
#' @param ncGTWinput A list in which each element is a \code{\link{ncGTWinput}}
#'   object.
#' @param sampleRt A list of the same length as the sample number in which each
#'   element is a vector corresponding to the sample raw/adjusted RT.
#' @details This function computes the pairwise correlation and overlapping area
#' of each sample pair from the input feature, and then takes average.
#' @return A list in which the first element is average pairwise correlation,
#' and the second one is average overlapping area.
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#' xcmsSmallWin <- xcmsExamples$xcmsSmallWin
#' ppm <- xcmsExamples$ppm
#'
#' # detect misaligned features
#' excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
#'
#' # obtain the paths of the sample files
#' filepath <- system.file("extdata", package = "ncGTW")
#' file <- list.files(filepath, pattern="mzxml", full.names=TRUE)
#'
#' tempInd <- matrix(0, length(file), 1)
#' for (n in seq_along(file)){
#'     tempCha <- file[n]
#'     tempLen <- nchar(tempCha)
#'     tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
#'         tempLen - 6))
#' }
#' # sort the paths by data acquisition order
#' file <- file[sort.int(tempInd, index.return = TRUE)$ix]
#'
#' # load the sample profiles
#' ncGTWinputs <- loadProfile(file, excluGroups)
#'
#' XCMSCor <- matrix(0, length(ncGTWinputs), 1)
#' XCMSOl <- matrix(0, length(ncGTWinputs), 1)
#' for (n in seq_along(ncGTWinputs)){
#'     XCMSmean <- meanCorOl(ncGTWinputs[[n]],
#'         slot(xcmsLargeWin, 'rt')$corrected)
#'     XCMSCor[n] <- XCMSmean$cor
#'     XCMSOl[n] <- XCMSmean$ol
#' }
#' @export

meanCorOl <- function(ncGTWinput, sampleRt){
    if (!is(ncGTWinput, 'ncGTWinput'))
        stop('ncGTWoutput should be a "ncGTWoutput" object.')

    samNum <- dim(ncGTWinput@rtRaw)[1]

    if (length(sampleRt) != samNum)
        stop('sampleRt should be a list with length as same as sample number.')

    pointNum <- dim(ncGTWinput@rtRaw)[2]
    profiles <- ncGTWinput@profiles
    rtRange <- matrix(0, samNum, pointNum)
    for (n in seq_len(samNum)){
        profiles[n, ] <- gaussFilter(profiles[n, ])
        rtRange[n, ] <- sampleRt[[n]][ncGTWinput@rtRaw[n, ]]
    }
    proInter <- matrix(0, samNum, pointNum * 10)
    interX <- seq(max(rtRange[ , 1]), min(rtRange[ , pointNum]),
                    length.out=pointNum * 10)
    for (n in seq_len(samNum))
        proInter[n, ] <- approx(rtRange[n, ], profiles[n, ], interX,
                                yleft=NA, yright=NA)$y
    corM <- cor(t(proInter))
    olM <- matrix(0, samNum, samNum)
    for (i in seq_len(samNum))
        for (j in i:samNum){
            olM[i, j] <- sum(pmin(proInter[i, ], proInter[j, ])) /
                min(sum(proInter[i, ]), sum(proInter[j, ]))
            olM[j, i] <- olM[i, j]
        }
    return(list(cor=mean(corM), ol=mean(olM)))
}


#' Compare CV
#'
#' This function calculates the coefficient of variation of each feature.
#' @param XCMSresFilled A \code{\link[xcms]{xcmsSet-class}} object.
#' @param na.rm Omit the samples in which the feature is not detected, and the
#'   default is FALSE.
#' @details This function calculates the coefficient of variation of each
#' feature across all the samples. If a sample is detected with more than one
#' peaks in the feature, the function will pick the one with the highest
#' intensity value.
#' @return A vector of the same length as the row number of the \code{group}
#' slot in \code{XCMSresFilled}, in which each element is the CV.
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#'
#' cv <- compCV(xcmsLargeWin)
#' @export

compCV <- function(XCMSresFilled, na.rm = FALSE){
    if (!is(XCMSresFilled, 'xcmsSet'))
        stop('XCMSresFilled should be a "xcmsSet" object.')

    groupNum <- dim(XCMSresFilled@groups)[1]
    sampleNum <- max(XCMSresFilled@peaks[, 'sample'])

    XCMSpeaks <- matrix(0, groupNum, sampleNum)
    XCMScv <- matrix(0, groupNum, 1)

    for (n in seq_len(groupNum)){
        XCMSgroupPeaks <- XCMSresFilled@peaks[XCMSresFilled@groupidx[[n]], ]

        XCMSonePeak <- matrix(0, sampleNum, dim(XCMSresFilled@peaks)[2])
        colnames(XCMSonePeak) <- colnames(XCMSgroupPeaks)

        for (m in seq_len(sampleNum)){
            XCMSpeakInd <- which(XCMSgroupPeaks[, 'sample'] == m)
            XCMSpeakInd <- XCMSpeakInd[which.max(XCMSgroupPeaks[XCMSpeakInd,
                                                                'into'])]
            if (length(XCMSpeakInd) == 0){
                XCMSonePeak[m, ] <- NA
            } else{
                XCMSonePeak[m, ] <- XCMSgroupPeaks[XCMSpeakInd, ]
            }
        }
        XCMSpeaks[n, ] <- XCMSonePeak[ , 'into']
        XCMScv[n] <- sd(XCMSpeaks[n, ], na.rm = na.rm)/mean(XCMSpeaks[n, ],
                                                            na.rm = na.rm)
    }
    return(XCMScv)
}




gaussFilter <- function(prof, sig=1){
    sz <- ceiling(sig * 6)    # length of gaussian filter vector
    if (sz < 2){
        sz <- 2
    }
    if (sz %% 2 != 0){
        sz <- sz + 1
    }
    x <- seq(-sz / 2, sz / 2, length=sz + 1)
    filterVec <- exp(-x ^ 2 / (2 * sig ^ 2))
    filterVec <- filterVec / sum (filterVec) # normalize
    filtered <- convolve(prof, filterVec, type='open')
    return(filtered[(sz / 2 + 1):(length(filtered) - sz / 2)])
}

rt2scan <- function(rt, rtAll)
    return(which.min(abs(rtAll - rt)))

smoTest <- function(xcmsLargeWin, groupInd, dataSub, scanRange,
                    sampleInd, path2, downSample, scanRangeOld){

    peaks <- xcmsLargeWin@peaks
    groupidx <- xcmsLargeWin@groupidx
    rtXCMS <- xcmsLargeWin@rt$corrected
    rtRaw <- xcmsLargeWin@rt$raw

    prePeaks <- findUniPeak(peaks, groupInd, groupidx, sampleInd=sampleInd)

    if (length(prePeaks) == 0 || length(unique(prePeaks[ , 'sample'])) == 1)
        return(matrix(-1, 3, 3))

    prePeakInd <- prePeaks[ , 'sample']
    prePeakMed <- prePeaks[, 'rt']

    sampleCount <- table(prePeakInd)
    groupNum <- max(sampleCount)
    groupSam <- as.numeric(names(which(sampleCount == groupNum)))
    maxNum <- 0
    maxRange <- 0
    maxInd <- 1
    for (ind in seq_len(length(groupSam))){
        samPeaks <- prePeaks[prePeaks[ , 'sample'] == groupSam[ind], 'rt']
        tempNum <- length(samPeaks)
        if (tempNum < maxNum )
            next
        tempRange <- max(samPeaks) - min(samPeaks)
        if (tempNum > maxNum ){
            maxNum <- tempNum
            maxRange <- tempRange
            maxInd <- groupSam[ind]
        } else if (tempRange > maxRange){
            maxRange <- tempRange
            maxInd <- groupSam[ind]
        }
    }
    groupSam <- maxInd

    if (groupNum == 1){
        kmeansPreInd <- kmeans(prePeakMed, 1)
    } else{
        kmeansPreInd <- kmeans(prePeakMed, prePeakMed[prePeakInd == groupSam])
    }

    oriPeakGroup <- vector('list', groupNum)
    XCMSPeakGroup <- vector('list', groupNum)
    ncGTWPeakGroup <- vector('list', groupNum)

    for (n in seq_len(groupNum))
        XCMSPeakGroup[[n]] <- prePeakMed[kmeansPreInd$cluster == n]

    ncGTWPeakMed <- prePeakMed * 0
    oriPeakMed <- prePeakMed * 0

    for (n in seq_len(length(ncGTWPeakMed))){
        samInd <- prePeaks[n, 'sample']
        samSubInd <- which(sampleInd == prePeaks[n, 'sample'])

        indDif <- abs(scanRange[samInd, ] - rt2scan(prePeakMed[n],
                                                    rtXCMS[[samInd]]))
        minIndDif <- min(indDif)
        medInd <- which(indDif == minIndDif)
        medInd <- medInd[which.max(dataSub[samSubInd, medInd])]
        fRange <- round(3 / mean(diff(rtRaw[[samInd]][scanRange[samInd,]])))
        if (medInd - fRange < 1){
            staInd <- 1
        } else {
            staInd <- medInd - fRange
        }
        if (medInd + fRange > dim(dataSub)[2]){
            endInd <- dim(dataSub)[2]
        } else{
            endInd <- medInd + fRange
        }
        apexRange <- staInd:endInd
        apexInd <- apexRange[which.max(dataSub[samSubInd, apexRange])]
        oriPeakMed[n] <- rtRaw[[samInd]][scanRange[samInd, apexInd]]

        samPath <- path2[[samSubInd]]


        scanSubncGTW <-
            round(mean(samPath[which(samPath[ , 2] == apexInd), 1]))
        scanncGTW <- (scanSubncGTW - 1) * downSample
        if (scanncGTW > dim(scanRangeOld)[2])
            scanncGTW <- dim(scanRangeOld)[2]
        ncGTWPeakMed[n] <- scanSubncGTW
    }
    oriPeakRt <- cbind(oriPeakMed, prePeaks[, 'rtmin'] - prePeakMed +
        oriPeakMed, prePeaks[, 'rtmax'] - prePeakMed + oriPeakMed)

    ncGTWPeakRt <- cbind(ncGTWPeakMed, ncGTWPeakMed)

    kmeansOriInd <-
        kmeans(oriPeakRt, oriPeakRt[prePeakInd == groupSam, , drop=FALSE])
    kmeansncGTWInd <-
        kmeans(ncGTWPeakRt, unique(ncGTWPeakRt[prePeakInd == groupSam, ,
            drop=FALSE]))

    for (n in seq_len(groupNum)){
        oriPeakGroup[[n]] <- oriPeakMed[kmeansOriInd$cluster == n]
        ncGTWPeakGroup[[n]] <- ncGTWPeakMed[kmeansncGTWInd$cluster == n]
    }

    statResult <- matrix(0, 3, 2)
    statResult[1, 1] <-
        sum(vapply(oriPeakGroup, var, vector("double", 1)), na.rm=TRUE)
    statResult[2, 1] <-
        sum(vapply(XCMSPeakGroup, var, vector("double", 1)), na.rm=TRUE)
    statResult[3, 1] <-
        sum(vapply(ncGTWPeakGroup, var, vector("double", 1)), na.rm=TRUE)
    statResult[1, 2] <- max(vapply(oriPeakGroup,
        function(x) range(x)[2] - range(x)[1], vector("double", 1)))
    statResult[2, 2] <- max(vapply(XCMSPeakGroup,
        function(x) range(x)[2] - range(x)[1], vector("double", 1)))
    statResult[3, 2] <- max(vapply(ncGTWPeakGroup,
        function(x) range(x)[2] - range(x)[1], vector("double", 1)))

    return(statResult)
}

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
    collapse=TRUE,
    comment="#>"
)

## ----eval = FALSE-------------------------------------------------------------
# devtools::install_github("ChiungTingWu/ncGTW")

## ----eval = FALSE-------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("ncGTW")

## ----eval = FALSE-------------------------------------------------------------
# excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)

## ----message = FALSE----------------------------------------------------------
library(xcms)
library(ncGTW)
filepath <- system.file("extdata", package = "ncGTW")
file <- list.files(filepath, pattern = "mzxml", full.names = TRUE)
# The paths of the 20 samples

## -----------------------------------------------------------------------------
tempInd <- matrix(0, length(file), 1)
for (n in seq_along(file)){
    tempCha <- file[n]
    tempLen <- nchar(tempCha)
    tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7, 
        tempLen - 6))
}
file <- file[sort.int(tempInd, index.return = TRUE)$ix]
# Sort the paths by data acquisition order to incorporate the RT structure

## ----message = FALSE, warning = FALSE-----------------------------------------
CPWmin <- 2 
CPWmax <- 25 
ppm <- 15 
xsnthresh <- 3 
LM <- FALSE
integrate <- 2 
RTerror <- 6 
MZerror <- 0.05
prefilter <- c(8, 1000)
# XCMS parameters
ds <- xcmsSet(file, method="centWave", peakwidth=c(CPWmin, CPWmax), ppm=ppm, 
    noise=xsnthresh, integrate=integrate, prefilter=prefilter)
gds <- group(ds, mzwid=MZerror, bw=RTerror)
agds <- retcor(gds, missing=5)
# XCMS peak detection and RT alignment

## ----message = FALSE----------------------------------------------------------
bwLarge <- RTerror
bwSmall <- 0.3
# Two different values of bw parameter
xcmsLargeWin <- group(agds, mzwid=MZerror, bw=bwLarge)
xcmsSmallWin <- group(agds, mzwid=MZerror, bw=bwSmall, minfrac=0)
# Two resolution of XCMS grouping results

## ----message = FALSE----------------------------------------------------------
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
# Detect misaligned features
show(excluGroups)

## ----message = FALSE----------------------------------------------------------
ncGTWinputs <- loadProfile(file, excluGroups)
# Load raw profiles from the files

## ----message = FALSE----------------------------------------------------------
for (n in seq_along(ncGTWinputs))
    plotGroup(ncGTWinputs[[n]], slot(xcmsLargeWin, 'rt')$corrected, ind=n)
    # (Optional) Draw the detected misaligned features

## ----message = FALSE----------------------------------------------------------
ncGTWoutputs <- vector('list', length(ncGTWinputs))
# Prepare the output variable
ncGTWparam <- new("ncGTWparam")
# Initialize the parameters of ncGTW alignment with default
for (n in seq_along(ncGTWinputs))
    ncGTWoutputs[[n]] <- ncGTWalign(ncGTWinputs[[n]], xcmsLargeWin, parSamp=5,
        bpParam=SnowParam(workers=4), ncGTWparam=ncGTWparam)
# Perform ncGTW alignment

## ----message = FALSE----------------------------------------------------------
ncGTWres <- xcmsLargeWin
# Prepare a new xcmsSet to contain the realignment result
ncGTWRt <- vector('list', length(ncGTWinputs))
for (n in seq_along(ncGTWinputs)){
    adjustRes <- adjustRT(ncGTWres, ncGTWinputs[[n]], ncGTWoutputs[[n]], ppm)
    # Generate the new warping functions
    peaks(ncGTWres) <- ncGTWpeaks(adjustRes)
    # Relocate the peaks to the new RT points according to the realignment.  
    ncGTWRt[[n]] <- rtncGTW(adjustRes)
    # Temporary variable for new warping functions 
}

## ----message = FALSE----------------------------------------------------------
for (n in seq_along(ncGTWinputs))
    plotGroup(ncGTWinputs[[n]], ncGTWRt[[n]], ind = n)
    # (Optional) Draw the realigned features

## ----message = FALSE----------------------------------------------------------
groups(ncGTWres) <- excluGroups[ , 2:9]
groupidx(ncGTWres) <- groupidx(xcmsLargeWin)[excluGroups[ , 1]]
# Only consider the misaligned features
rtCor <- vector('list', length(file))
for (n in seq_along(file)){
    rtCor[[n]] <- vector('list', dim(excluGroups)[1])
    for (m in seq_len(dim(groups(ncGTWres))[1]))
        rtCor[[n]][[m]] <- ncGTWRt[[m]][[n]]
}
slot(ncGTWres, 'rt')$corrected <- rtCor
# Replace the XCMS warping function to ncGTW warping function
XCMSres <- xcmsLargeWin
groups(XCMSres) <- excluGroups[ , 2:9]
groupidx(XCMSres) <- groupidx(xcmsLargeWin)[excluGroups[ , 1]]
# Consider only the misaligned features with XCMS warping function

## ----message = FALSE----------------------------------------------------------
assignInNamespace("fillPeaksChromPar", ncGTW:::fillPeaksChromPar, ns="xcms",
    envir=as.environment("package:xcms"))
# Replace fillPeaksChromPar() in XCMS
ncGTWresFilled <- fillPeaks(ncGTWres)
XCMSresFilled <- fillPeaks(XCMSres)
# Peak-filling with old and new warping functions
compCV(XCMSresFilled)
compCV(ncGTWresFilled)
# Compare the coefficient of variation

#' Run ncGTW alignment
#'
#' This function applies ncGTW alignment to the input feature.
#' @param ncGTWinput A \code{\link{ncGTWinput}} object.
#' @param xcmsLargeWin A \code{\link[xcms]{xcmsSet-class}} object.
#' @param parSamp Decide how many samples are in each group when considering
#'   parallel computing, and the default is 10.
#' @param k1Num Decide how many different k1 will be tested in stage 1. The
#'   default is 3.
#' @param k2Num Decide how many different k2 will be tested in stage 2. The
#'   default is 1.
#' @param bpParam A object of \pkg{BiocParallel} to control parallel processing,
#'   and can be created by
#'   \code{\link[BiocParallel:SerialParam-class]{SerialParam}},
#'   \code{\link[BiocParallel:MulticoreParam-class]{MulticoreParam}}, or
#'   \code{\link[BiocParallel:SnowParam-class]{SnowParam}}.
#' @param ncGTWparam A \code{\link{ncGTWparam}} object.
#' @details This function realign the input feature with ncGTW alignment
#' function with given m/z and RT range.
#' @return A \code{\link{ncGTWoutput}} object.
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#' xcmsSmallWin <- xcmsExamples$xcmsSmallWin
#' ppm <- xcmsExamples$ppm
#'
#' # detect misaligned features
#' excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
#'
#' # obtain the paths of the sample files
#' filepath <- system.file("extdata", package = "ncGTW")
#' file <- list.files(filepath, pattern="mzxml", full.names=TRUE)
#'
#' tempInd <- matrix(0, length(file), 1)
#' for (n in seq_along(file)){
#'     tempCha <- file[n]
#'     tempLen <- nchar(tempCha)
#'     tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
#'         tempLen - 6))
#' }
#' # sort the paths by data acquisition order
#' file <- file[sort.int(tempInd, index.return = TRUE)$ix]
#' \dontrun{
#' # load the sample profiles
#' ncGTWinputs <- loadProfile(file, excluGroups)
#'
#' # initialize the parameters of ncGTW alignment with default
#' ncGTWparam <- new("ncGTWparam")
#'
#' # run ncGTW alignment
#' ncGTWoutputs <- vector('list', length(ncGTWinputs))
#' for (n in seq_along(ncGTWinputs))
#'     ncGTWoutputs[[n]] <- ncGTWalign(ncGTWinputs[[n]], xcmsLargeWin, 5,
#'         ncGTWparam = ncGTWparam)
#' }
#' @export

ncGTWalign <- function(ncGTWinput, xcmsLargeWin, parSamp=10, k1Num=3, k2Num=1,
    bpParam=BiocParallel::SnowParam(workers=1), ncGTWparam=NULL){

    if (!is(xcmsLargeWin, 'xcmsSet'))
        stop('xcmsLargeWin should be a "xcmsSet" object.')
    if (!is(ncGTWinput, 'ncGTWinput'))
        stop('ncGTWinput should be a "ncGTWinput" object.')
    if (parSamp <= 1 || parSamp %% 1 != 0)
        stop('parSamp should be an integer which is larger than 1.')
    if (k1Num <= 0 || k1Num %% 1 != 0)
        stop('k1Num should be an integer which is larger than 0.')
    if (k2Num <= 0 || k2Num %% 1 != 0)
        stop('k2Num should be an integer which is larger than 0.')

    ncGTWparam <- initHidparam(ncGTWparam, ncGTWinput, k1Num, k2Num)
    groupInd <- ncGTWinput@groupInfo[1]
    scanRangeOld <- ncGTWinput@rtRaw

    ncGTWpar <- ncGTWsplit(ncGTWinput, ncGTWparam, parSamp)
    parSamp <- ncGTWpar$parSamp
    parSect <- ncGTWpar$parSect
    parNum <- ncGTWpar$parNum
    specLen <- ncGTWpar$specLen
    scanRange <- ncGTWpar$scanRange

    message("ncGTW is realigning group ", groupInd, "...")

    ## ncGTW 1st layer alignment
    ncGTW1stOutput <- BiocParallel::bplapply(ncGTWpar$parInfos, ncGTW1stLayer,
        xcmsLargeWin, scanRange, scanRangeOld, ncGTWparam, BPPARAM=bpParam)

    parPath <- replicate(parSect, list(vector('list', parSamp)))
    parWarped <- array(0, c(parSamp, specLen, parSect))
    parStat <- array(0, c(k1Num * k2Num, 5, parSect))

    for (n in seq_len(parSect)){
        parPath[[n]] <- ncGTW1stOutput[[n]]$parPath
        parWarped[seq_len(parNum[n]) , , n] <- ncGTW1stOutput[[n]]$parWarped
        parStat[ , , n] <- ncGTW1stOutput[[n]]$parStat
    }

    ## Stop if only 1 layer
    if (parSect == 1){
        warning('Only one layer!!!')
        warpedAll <- parWarped[ , , 1]
        smoM2 <- matrix(0, 3, 6)

        return(new("ncGTWoutput", alignData=ncGTWpar$data, scanRange=scanRange,
            ncGTWpath=parPath[[1]], downSample=downSample))
    }

    ## Build super samples for 2nd layer
    superSample <- matrix(0, parSect, specLen)
    for (n in seq_len(parSect)){
        maxInd <- which.max(rowSums(parWarped[ , , n], 2))
        minInd <- which.min(rowSums(parWarped[ , , n], 2))
        superSample[n, ] <- colMeans(parWarped[setdiff(seq_len(parNum[n]),
            c(maxInd, minInd)), , n, drop=FALSE])
    }

    ## ncGTW 2nd layer alignment
    ncGTWparam2 <- ncGTWparam
    if (ncGTWparam2$maxStp * 1.5 > specLen){
        ncGTWparam2$maxStp <- specLen - 1
    } else{
        ncGTWparam2$maxStp <- round(ncGTWparam$maxStp * 1.5)
    }
    ncGTWparam2$mir <- FALSE

    allInfo <- list(groupInd=groupInd, num=0, all=0, parSpec=superSample,
        parNum=parSect, parInd=seq_len(parSect))

    ncGTWsmoRes2 <- ncGTWalignSmo(allInfo, xcmsLargeWin, scanRange,
        scanRangeOld, ncGTWparam2, TRUE, ncGTWpar$data, parPath,
        ncGTWpar$parInd)

    smoM2 <- ncGTWsmoRes2$smoM
    minRange <- min(smoM2[ , 3])
    bestSmo <- which(smoM2[ , 3] == minRange)
    bestSmo <- bestSmo[which.min(smoM2[bestSmo, 1])]

    path2 <- ncGTWsmoRes2$tempPath[[bestSmo]]

    ## Warp samples
    parSuperWarped <- matrix(0, parSect, specLen)
    for (m in seq_len(parSect))
        parSuperWarped[m, ] <- warpCurve(superSample[m, ], path2[[m]])

    warpedAll <- matrix(0, dim(ncGTWpar$data)[1], dim(ncGTWpar$data)[2])
    tempCount <- 0
    for (n in seq_len(parSect)){
        for (m in seq_len(parNum[n]))
            warpedAll[tempCount + m, ] <-
                warpCurve(parWarped[m, , n], path2[[n]])
        tempCount <- tempCount + parNum[n]
    }

    path <- pathCombine(parPath, path2, ncGTWpar$parInd)

    return(new("ncGTWoutput", alignData=ncGTWpar$data, scanRange=scanRange,
        ncGTWpath=path, downSample=ncGTWparam$downSample))
}


initHidparam <- function(ncGTWparam, ncGTWinput, k1Num, k2Num){

    ncGTWparam2 <- list()

    ncGTWparam2$downSample <- if (is.null(ncGTWparam@downSample)) 2 else
        ncGTWparam@downSample

    ncGTWparam2$nor <- if (is.null(ncGTWparam@nor)) 1 else ncGTWparam@nor

    ncGTWparam2$strNum <- if (is.null(ncGTWparam@strNum)) 1 else
        ncGTWparam@strNum

    ncGTWparam2$diaNum <- if (is.null(ncGTWparam@diaNum)) 1 else
        ncGTWparam@diaNum

    ncGTWparam2$mir <- TRUE

    ncGTWparam2$stpRat <- if (is.null(ncGTWparam@stpRat)) 0.6 else
        ncGTWparam@stpRat

    ncGTWparam2$maxStp <- if (is.nan(ncGTWparam@maxStp))
        round(dim(ncGTWinput@rtRaw)[2] %/% ncGTWparam2$downSample *
            ncGTWparam2$stpRat) else ncGTWparam@maxStp

    ncGTWparam2$rangeThre <- 1
    ncGTWparam2$biP <- TRUE
    ncGTWparam2$mu <- 0
    ncGTWparam2$sigma <- 1
    ncGTWparam2$weiP <- 0
    ncGTWparam2$logt <- 0
    ncGTWparam2$dia <- 0
    ncGTWparam2$noiseVar <- 1
    ncGTWparam2$k1Num <- k1Num
    ncGTWparam2$k2Num <- k2Num

    return(ncGTWparam2)
}


ncGTWsplit <- function(ncGTWinput, ncGTWparam, parSamp){

    downSample <- ncGTWparam$downSample

    dataOri <- ncGTWinput@profiles
    dataFil <- t(apply(dataOri, 1, gaussFilter))

    dataNum <- dim(dataFil)[1]
    specLen <- dim(dataFil)[2]

    data <- matrix(0, dataNum, specLen %/% downSample)
    scanRange <- matrix(0, dataNum, specLen %/% downSample)
    for (i in seq_len(dataNum)){
        for (j in seq_len(specLen %/% downSample)){
            subInd <- ((j - 1) * downSample + 1):(j * downSample)
            maxInd <- which.max(dataFil[i, subInd])
            data[i, j] <- dataFil[i, subInd[maxInd]]
            scanRange[i, j] <- ncGTWinput@rtRaw[i, subInd[maxInd]]
        }
    }
    data <- cbind(dataFil[ , 1], data)
    scanRange <- cbind(ncGTWinput@rtRaw[ , 1], scanRange)
    if (any(data[ , dim(data)[2]] != dataFil[ , specLen])){
        data <- cbind(data, dataFil[ , specLen])
        scanRange <- cbind(scanRange, ncGTWinput@rtRaw[ , specLen])
    }
    specLen <- dim(data)[2]

    parSect <- dataNum / parSamp
    if (parSect > floor(dataNum / parSamp)){
        parSect <- floor(dataNum / parSamp) + 1
    }

    parSpec <- array(0, c(parSamp, specLen, parSect))
    parInd <- matrix(0, parSamp, parSect)

    parNum <- matrix(0, parSect, 1) + parSamp
    if ((dataNum - (parSect - 1) * parSamp  ) > parSamp / 2){
        parNum[parSect] <- dataNum - (parSect - 1) * parSamp
    } else{
        parNum[parSect - 1] <- ceiling((dataNum - (parSect - 2) * parSamp) / 2)
        parNum[parSect] <- floor((dataNum - (parSect - 2) * parSamp) / 2)
    }

    tempCount <- 0
    for (n in seq_len(parSect)){
        parSpec[seq_len(parNum[n]), , n] <-
            data[(tempCount + 1):(tempCount + parNum[n]), ]
        parInd[seq_len(parNum[n]), n] <- (tempCount + 1):(tempCount + parNum[n])
        tempCount <- tempCount + parNum[n]
    }

    parInfos <- vector('list', parSect)
    for (n in seq_len(parSect)){
        parInfos[[n]]$groupInd <- ncGTWinput@groupInfo['index']
        parInfos[[n]]$num <- n
        parInfos[[n]]$all <- parSect
        parInfos[[n]]$parSpec <- parSpec[seq_len(parNum[n]), , n]
        parInfos[[n]]$parNum <- parNum[n]
        parInfos[[n]]$parInd <- parInd[ , n]
    }
    return(list(parInfos=parInfos, scanRange=scanRange, parSamp=parSamp,
        specLen=specLen, parSect=parSect, parNum=parNum, data=data,
        parInd=parInd))
}


ncGTW1stLayer <- function(parInfo, xcmsLargeWin, scanRange, scanRangeOld,
    ncGTWparam){

    ncGTWsmoRes <- ncGTWalignSmo(parInfo, xcmsLargeWin, scanRange, scanRangeOld,
        ncGTWparam)

    warpRes <- chooseSmo(ncGTWsmoRes$smoM, ncGTWsmoRes$tempPath, parInfo,
        ncGTWparam)

    return(list(parPath=warpRes$parPath, parWarped=warpRes$parWarped,
        parStat=warpRes$parStat, parS1BrokenNum=ncGTWsmoRes$parS1BrokenNum,
        parS2BrokenNum=ncGTWsmoRes$parS2BrokenNum, parS2=ncGTWsmoRes$parS2))
}

ncGTWalignSmo <- function(parInfo, xcmsLargeWin, scanRange,
    scanRangeOld, ncGTWparam, second=FALSE, data=NULL, parPath=NULL,
    parInd=NULL){

    groupInd <- parInfo$groupInd
    n <- parInfo$num
    parSect <- parInfo$all
    parnum <- parInfo$parNum
    parind <- parInfo$parInd[seq_len(parnum)]
    parspec <- parInfo$parSpec[seq_len(parnum), ]

    mir <- ncGTWparam$mir
    strNum <- ncGTWparam$strNum
    diaNum <- ncGTWparam$diaNum
    biP <- ncGTWparam$biP
    noiseVar <- ncGTWparam$noiseVar
    downSample <- ncGTWparam$downSample
    rangeThre <- ncGTWparam$rangeThre
    maxStp <- ncGTWparam$maxStp
    k1Num <- ncGTWparam$k1Num
    k2Num <- ncGTWparam$k2Num

    gtwPrep <- buildMultiParaValidmap(parspec, mir, strNum, diaNum, biP)
    eeBet <- betEdge(gtwPrep, 10^-32, ncGTWparam)

    gtwRes0 <- gtwCut(gtwPrep, 0, ncGTWparam)
    cut0 <- gtwRes0$cut
    costMin <- cut0[length(gtwRes0$cut)]
    s1BrokenNum <- sum((cut0[eeBet[ ,1]] + cut0[eeBet[ ,2]]) == 1)
    parS1BrokenNum <- s1BrokenNum #####

    gtwResMerge <- gtwCut(gtwPrep, 10^32, ncGTWparam, 2)
    cutMerge <- gtwResMerge$cut
    costMax <- cutMerge[length(cutMerge)]
    smoTemp <- (costMax - costMin) / s1BrokenNum

    BNumDTW1 <- matrix(-1, 3, 3)
    BNumDTW1[1, 1] <- 0
    BNumDTW1[2, 1] <- s1BrokenNum
    BNumDTW1[3, 1] <- costMin
    BNumDTW1[1, 3] <- Inf
    BNumDTW1[2, 3] <- 0
    BNumDTW1[3, 3] <- costMax

    smoM <- array(999, c(k1Num, k2Num, 5))
    smoM[1, ,1] <- smoTemp
    BNumDTW1[1, 2] <- smoTemp
    tempPath <- vector('list', k1Num * k2Num)

    for (smo in seq_len(dim(smoM)[1])){
        gtwRes1 <- gtwCut(gtwPrep, smoM[smo, 1,1], ncGTWparam)
        cut1 <- gtwRes1$cut
        gtwInfo1 <- gtwRes1$gtwInfo
        path1 <- label2path(gtwRes1$cut, gtwRes1$gtwInfo)
        if (n != 0){
            message(format(Sys.time()),
                ' Solved the 1st maximum flow, section ', n, ' of ', parSect,
                ', bottom layer.')
        } else{
            message(format(Sys.time()),
                ' Solved the 1st maximum flow, top layer.')
        }
        brokenNum1 <- sum((cut1[eeBet[ ,1]] + cut1[eeBet[ ,2]]) == 1)
        tempInd <- (smo - 2^floor(log2(smo)) + 1) * 2
        BNumDTW1[2, tempInd] <- brokenNum1
        BNumDTW1[3, tempInd] <- cut1[length(cut1)] - smoM[smo, 1,1] * brokenNum1
        smoM[smo, ,2] <- brokenNum1

        validMap2 <- matrix(0, parnum, parnum)
        for (jj in seq_len(parnum))
            for (ii in seq((jj + 1), parnum, length = max(0, parnum - jj)))
                validMap2[ii, jj] <- 1
        tst2 <- matrix(0, dim(parspec)[1], dim(parspec)[2])
        ref2 <- tst2
        smoothnessV2 <- 0.0000000001 / noiseVar

        gtwPrep2 <- list(validMap=validMap2, tst=tst2, ref=ref2)
        gtwRes2 <- gtwCut(gtwPrep2, smoothnessV2, ncGTWparam, 1, path1,
            gtwPrep$pairMap)
        eeBet2 <- gtwRes2$eeBet
        s2BrokenNum <- gtwRes2$cut[length(gtwRes2$cut)] / smoothnessV2
        parS2BrokenNum <- s2BrokenNum #####
        parS2 <- 2 * (maxStp - 1) * parnum / s2BrokenNum ###############
        smoothnessV2 <- parS2 / noiseVar

        BNumDTW2 <- matrix(-1, 3, 3)
        BNumDTW2[1, 1] <- 0
        BNumDTW2[2, 1] <- s2BrokenNum
        BNumDTW2[3, 1] <- 0
        BNumDTW2[1, 3] <- Inf
        BNumDTW2[2, 3] <- 0
        BNumDTW2[3, 3] <- 2 * (maxStp - 1) * parnum
        smoM[smo, 1, 4] <- smoothnessV2
        BNumDTW2[1, 2] <- smoothnessV2

        for (smo2 in seq_len(dim(smoM)[2])){

            gtwRes2 <- gtwCut(gtwPrep2, smoM[smo, smo2,4], ncGTWparam, 1, path1,
                gtwPrep$pairMap)
            cut2 <- gtwRes2$cut
            gtwInfo2 <- gtwRes2$gtwInfo
            path2 <- label2path(cut2, gtwInfo2)
            tempPath[[(smo-1) * k2Num + smo2]] <- path2
            if (n != 0){
                message(format(Sys.time()),
                    ' Solved the 2nd maximum flow, section ', n, ' of ', parSect,
                    ', bottom layer.')
            } else{
            message(format(Sys.time()),
                ' Solved the 2nd maximum flow, top layer.')
            }

            brokenNum2 <- sum((cut2[eeBet2[ ,1]] + cut2[eeBet2[ ,2]]) == 1)
            tempInd <- (smo2 - 2^floor(log2(smo2)) + 1) * 2
            BNumDTW2[2, tempInd] <- brokenNum2
            BNumDTW2[3, tempInd] <- cut2[length(cut2)] -
                smoM[smo, smo2, 4] * brokenNum2
            smoM[smo, smo2, 5] <- brokenNum2

            if (second){
                temp2path <- pathCombine(parPath, path2, parInd)
                statResult <- smoTest(xcmsLargeWin, groupInd, data, scanRange,
                    seq_len(dim(data)[1]), temp2path, downSample, scanRangeOld)
            } else{
                statResult <- smoTest(xcmsLargeWin, groupInd, parspec, scanRange,
                    parind, path2, downSample, scanRangeOld)
            }

            tempRange <- statResult[3, 2]


            smoM[smo, smo2, 3] <- tempRange

            if (tempRange <= rangeThre)
                break

            if ((as.integer(log2(smo2+1)) - log2(smo2+1)) == 0 &&
                smo2 < dim(smoM)[2]){

                tBNumDTW2 <- matrix(-1, 3, smo2*2 + 3)
                for (tsmo2 in seq_len(dim(tBNumDTW2)[2])){
                    if (as.integer(tsmo2/2) != tsmo2/2){
                        tBNumDTW2[, tsmo2] = BNumDTW2[,(tsmo2+1)/2]
                    } else{
                        tBNumDTW2[1, tsmo2] =
                            (BNumDTW2[3, tsmo2/2 + 1] - BNumDTW2[3, tsmo2/2]) /
                            (BNumDTW2[2, tsmo2/2] - BNumDTW2[2, tsmo2/2 + 1])
                        if (smo2 + tsmo2/2 <= dim(smoM)[2])
                            smoM[smo, smo2 + tsmo2/2, 4] = tBNumDTW2[1, tsmo2]
                    }
                }
                BNumDTW2 <- tBNumDTW2
            }
        }
        if (tempRange <= rangeThre)
            break

        if ((as.integer(log2(smo+1)) - log2(smo+1)) == 0 && smo < dim(smoM)[1]){
            tBNumDTW1 <- matrix(-1, 3, smo*2 + 3)
            for (tsmo in seq_len(dim(tBNumDTW1)[2])){
                if (as.integer(tsmo/2) != tsmo/2){
                    tBNumDTW1[, tsmo] = BNumDTW1[,(tsmo+1)/2]
                } else{
                    tBNumDTW1[1, tsmo] =
                        (BNumDTW1[3, tsmo/2 + 1] - BNumDTW1[3, tsmo/2]) /
                        (BNumDTW1[2, tsmo/2] - BNumDTW1[2, tsmo/2 + 1])
                    if (smo + tsmo/2 <= dim(smoM)[1])
                        smoM[smo + tsmo/2, ,1] = tBNumDTW1[1, tsmo]
                }
            }
            BNumDTW1 <- tBNumDTW1
        }
    }
    return(list(smoM=matrix(aperm(smoM, c(2,1,3)), k1Num * k2Num, 5),
        tempPath=tempPath, parS1BrokenNum = parS1BrokenNum,
        parS2BrokenNum = parS2BrokenNum, parS2 = parS2))
}


chooseSmo <- function(smoM, tempPath, parInfo, ncGTWparam, bestSmo=NULL){

    rangeThre <- ncGTWparam$rangeThre

    parnum <- parInfo$parNum
    parspec <- parInfo$parSpec[seq_len(parnum), ]

    if (is.null(bestSmo)){
        bestSmo <- which(smoM[ , 3] < rangeThre)##
        if (length(bestSmo) > 1){
            bestSmo <- bestSmo[which.max(smoM[bestSmo, 1] / smoM[bestSmo, 4])]
        } else if (length(bestSmo) == 0){
            bestSmo <- which.min(smoM[ , 3])
        }
    }

    path2 <- tempPath[[bestSmo]]##

    tempWarped <- parspec * 0
    for (m in seq_len(parnum))
        tempWarped[m, ] <- warpCurve(parspec[m, ], path2[[m]])

    parwarped <- tempWarped##

    tempPath2 <- vector('list', parnum)
    tempPath2[seq_len(parnum)] <- path2

    parpath <- tempPath2##
    parstat <- smoM    ##

    return(list(parPath=parpath, parWarped=parwarped, parStat=parstat))
}

gtwCut <- function(gtwPrep, smooth, ncGTWparam, type=0, path=NA, pairMap=NA){

    param <- initGtwParam(gtwPrep$validMap, ncGTWparam$noiseVar,
        ncGTWparam$maxStp, smooth, ncGTWparam$dia, ncGTWparam$logt,
        ncGTWparam$nor)

    gtwInfo <- buildGTWgraph(gtwPrep$ref, gtwPrep$tst, gtwPrep$validMap, param,
        ncGTWparam$mu, ncGTWparam$sigma, ncGTWparam$biP, ncGTWparam$weiP, type,
        path, pairMap)

    eeBet <- gtwInfo$ee[gtwInfo$ee[, 3] == smooth & gtwInfo$ee[, 4] == smooth, ]

    cut <- graphCut(gtwInfo$ss, gtwInfo$ee)

    return(list(gtwInfo = gtwInfo, eeBet = eeBet, cut = cut))
}



betEdge <- function(gtwPrep, smooth, ncGTWparam){

    param <- initGtwParam(gtwPrep$validMap, ncGTWparam$noiseVar,
        ncGTWparam$maxStp, smooth, ncGTWparam$dia, ncGTWparam$logt,
        ncGTWparam$nor)

    gtwInfo <- buildGTWgraph(gtwPrep$ref, gtwPrep$tst, gtwPrep$validMap, param,
        ncGTWparam$mu, ncGTWparam$sigma, ncGTWparam$biP, ncGTWparam$weiP)

    eeBet <-
        gtwInfo$ee[(gtwInfo$nEdgeGrid * gtwInfo$nPix + 1):dim(gtwInfo$ee)[1], ]

    return(eeBet)
}

#' @useDynLib ncGTW
#' @importFrom Rcpp sourceCpp
NULL

#' Class "ncGTWparam"
#'
#' An S4 class for storing the needed paramters of ncGTW alignment.
#'
#' @slot downSample A factor of downsampling. The larger, the faster speed
#'   of alignment, but the accuracy may decrease. The default is 2.
#' @slot stpRat A factor to control the maximum RT shift of a point in
#'   alignment, and the maximum shift is determined by \code{stpRat} * "The RT
#'   range of the feature". If \code{maxStp} is set, then \code{stpRat} would be
#'   neglected. The default is 0.6.
#' @slot maxStp A value determines the maximum RT shift of a point in ncGTW
#'   alignment. If the user wants to decide the maximum shif by the RT range of
#'   the feature, this argument should be NaN. The default is NaN.
#' @slot strNum A value controls how many neighboring warping functions are
#'   connected to each warping function in ncGTW graph. There are two samples
#'   corresponding to a warping function, and at least one sample should be the
#'   same in another warping function to be considered as a neighbor controlled
#'   by \code{strNum}.
#' @slot diaNum A value controls how many neighboring warping functions are
#'   connected to each warping function in ncGTW graph. There are two samples
#'   corresponding to a warping function, and the two samples could also be
#'   different to another warping function to be considered as a neighbor
#'   controlled by \code{diaNum}.
#' @slot nor A value controls p-norm to compute the distance between the
#'   points on the profiles, and the default is 1 (Manhattan norm).
#' @details This function initializes the needed paramters of ncGTW alignment
#' with defaults, so this function could be called without any input. The
#' alignment should be fine with all default parameters. If the computing time
#' is an issue, the user could consider increase \code{downSample} and/or
#' decrease \code{stpRat} for a faster speed. If the alignment result is not
#' good enough, one can consider increase \code{strNum} and/or \code{diaNum}
#' to integrate more neighboring information to increase the quality of
#' alignment, but the speed may drop.

ncGTWparam <- setClass("ncGTWparam", slots=c(downSample="numeric",
                        stpRat="numeric", maxStp="numeric",
                        strNum="numeric", diaNum="numeric", nor="numeric")
)


#' Class "ncGTWinput"
#'
#' An S4 class for storing the inputs of ncGTW alignment.
#'
#' @slot groupInfo  A vector of the information of the feature.
#' @slot profiles   A raw data matrix in which each row is a sample profile.
#' @slot rtRaw      A raw RT matrix in which each row is the corresponding
#'   sample RT in \code{profiles}.

ncGTWinput <- setClass("ncGTWinput", slots=c(groupInfo="vector",
    profiles="matrix", rtRaw="matrix")
)

valid_ncGTWinput <- function(object) {
    errors <- character()

    cName <- c("mzmed", "mzmin", "mzmax", "rtmed", "rtmin", "rtmax")
    if (!all(cName %in% names(object@groupInfo))){
        msg <- paste0("'groupInfo' must contain names: ",
                    paste(cName,collapse=', '), '.')
        errors <- c(errors, msg)
    }

    if (!all(dim(object@profiles) == dim(object@rtRaw))) {
        msg <- "The dimension of 'profiles' and 'rtRaw' must be the same."
        errors <- c(errors, msg)
    }

    if (length(errors) == 0) TRUE else errors
}

setValidity("ncGTWinput", valid_ncGTWinput)


#' Class "ncGTWoutput"
#'
#' An S4 class for storing the outputs of ncGTW alignment.
#'
#' @slot alignData  A matrix in which each row is a sample profile after
#'   downsampling.
#' @slot scanRange  A downsampled RT matrix in which each row is the
#'   corresponding sample RT in \code{alignData}.
#' @slot path       A list of the same length as the sample number, in which
#'   each element is a matrix of the alignment result of the corresponding
#'   sample.
#' @slot downSample      The factor of downsampling when perform ncGTW
#'   alignment.

ncGTWoutput <- setClass("ncGTWoutput", slots=c(alignData="matrix",
    scanRange="matrix", ncGTWpath="list", downSample="numeric")
)

valid_ncGTWoutput <- function(object) {
    errors <- character()

    if (!all(dim(object@alignData) == dim(object@scanRange))) {
        msg <- "The dimension of 'alignData' and 'scanRange' must be the same."
        errors <- c(errors, msg)
    }

    if (nrow(object@alignData) != length(object@ncGTWpath)) {
        msg <- paste("The row number of 'alignData' and the length of",
                "'ncGTWpath' must be the same (sample number).")
        errors <- c(errors, msg)
    }

    if (object@downSample < 1) {
        msg <- paste("The value of 'downSample' must be larger or equal to 1.")
        errors <- c(errors, msg)
    }

    if (length(errors) == 0) TRUE else errors
}

setValidity("ncGTWoutput", valid_ncGTWoutput)


#' Class "ncGTWwarp"
#'
#' An S4 class for storing the realigned RT and the peaks with adjusted RT of
#' ncGTW alignment.
#'
#' @slot rtncGTW    A list of the same length as the sample number, in which
#'   each element is a vector of the realigned RT of the corresponding sample.
#' @slot ncGTWpeaks A matrix containing peak data with adjusted RT.

ncGTWwarp <- setClass("ncGTWwarp", slots=c(rtncGTW="list", ncGTWpeaks="matrix"))

valid_ncGTWwarp <- function(object) {
    errors <- character()

    cName <- c("mz", "mzmin", "mzmax", "rt", "rtmin", "rtmax", "into", "intb",
                "maxo", "sn", "sample")
    if (!all(cName %in% colnames(object@ncGTWpeaks))){
        msg <- paste0("'ncGTWpeaks' must contain column names: ",
            paste(cName,collapse=', '), '.')
        errors <- c(errors, msg)
    }

    if (length(errors) == 0) TRUE else errors
}

setValidity("ncGTWwarp", valid_ncGTWwarp)

#' Edited XCMS fillPeaksChromPar for feature-wise warping functions
#'
#' This function is edited from \code{fillPeaksChromPar} in
#' \code{\link[xcms]{fillPeaks.chrom-methods}} to accept feature-wise warping
#' functions.
#' @param arg A list sent from \code{\link[xcms]{fillPeaks.chrom-methods}}.
#' @details This function is for parallelly filling missing peaks with
#' feature-wise warping functions. The original function in
#' \code{\link[xcms]{fillPeaks.chrom-methods}} can only handle sample-wise
#' warping functions.
#' @return A list of sameple index vector and filled peak matrix.

fillPeaksChromPar <- function(arg) {

    suppressMessages(requireNamespace("xcms", quietly=TRUE))
    suppressMessages(requireNamespace("ncGTW", quietly=TRUE))
    message('This is edited from XCMS (fillPeaksChromPar).....')

    params <- arg$params
    myID <- arg$id
    message(arg$file)

    prof <- params$prof
    rtcor <- params$rtcor
    peakrange <- params$peakrange
    expand.mz <- params$expand.mz
    expand.rt <- params$expand.rt
    gvals <- params$gvals$gvals

    lcraw <- xcmsRaw(arg$file, profmethod=params$prof$method, profstep=0)

    if (length(params$dataCorrection) > 1) {
        ## Note: dataCorrection (as set in the xcmsSet function) is either
        ## 1 for all or for none.
        if (any(params$dataCorrection == 1))
            lcraw <- stitch(lcraw, AutoLockMass(lcraw))
    }

    if (exists("params$polarity") && length(params$polarity) > 0) {
        if (length(params$polarity) > 0) {
            ## Retain wanted polarity only
            lcraws <- split(lcraw, lcraw@polarity, DROP=TRUE)
            lcraw <- lcraws[[params$polarity]]
        }
    }


    if (!is.list(rtcor))
        rtcor <- list(rtcor)
    lcraw@profparam <- rtcor

    ## Expanding the peakrange
    incrMz <- (peakrange[, "mzmax"] - peakrange[, "mzmin"]) / 2 * (expand.mz -1)
    peakrange[, "mzmax"] <- peakrange[, "mzmax"] + incrMz
    peakrange[, "mzmin"] <- peakrange[, "mzmin"] - incrMz
    incrRt <- (peakrange[, "rtmax"] - peakrange[, "rtmin"]) / 2 * (expand.rt -1)
    peakrange[, "rtmax"] <- peakrange[, "rtmax"] + incrRt
    peakrange[, "rtmin"] <- peakrange[, "rtmin"] - incrRt

    naidx <- which(is.na(gvals[,myID]))

    newpeaks <- getPeaksncGTW(lcraw, peakrange[naidx, , drop=FALSE],
        step=prof$step, naidx)



    list(myID=myID, newpeaks=cbind(newpeaks, sample=myID))
}

#' Edited XCMS getPeaks for feature-wise warping functions
#'
#' This function is edited from \code{\link[xcms]{getPeaks-methods}} to accept
#' feature-wise warping functions.
#' @param object An \code{\link[xcms]{xcmsRaw-class}} object.
#' @param peakrange \code{matrix} with 4 required columns \code{"mzmin"},
#'   \code{"mzmax"}, \code{"rtmin"} and \code{"rtmax"}.
#' @param step \code{numeric(1)} defining the bin size for the profile matrix
#'   generation.
#' @param naidx A vector contains the sample indexes need to be filled.
#' @details This function is for parallelly filling missing peaks with
#' feature-wise warping functions. The original code function in
#' \code{\link[xcms]{getPeaks-methods}} can only handle sample-wise warping
#' functions.
#' @return A list of sameple index vector and filled peak matrix.

getPeaksncGTW <- function(object, peakrange, step=0.1, naidx) {
    suppressMessages(requireNamespace("xcms", quietly=TRUE))
    message('ncGTW fillpeaks')
    ## Here we're avoiding the profFun call.
    if (all(c("mzmin","mzmax","rtmin","rtmax") %in% colnames(peakrange)))
        peakrange <- peakrange[,c("mzmin","mzmax","rtmin","rtmax"), drop=FALSE]
    stime <- object@profparam

    pi <- profinfo(object)
    method <- pi$method
    if (missing(step))
        step <- pi$step
    if (step == 0)
        step <- 0.1
    baselevel <- pi$baselevel
    basespace <- pi$basespace
    vps <- diff(c(object@scanindex, length(object@env$mz)))

    message("method_new: ", method, " ")
    message("step: ", step)
    ## Create the profile matrix:
    pMat <- xcms:::.createProfileMatrix(mz = object@env$mz,
                                        int = object@env$intensity,
                                        valsPerSpect = vps,
                                        method = method,
                                        step = step,
                                        baselevel = baselevel,
                                        basespace = basespace,
                                        returnBreaks = TRUE,
                                        baseValue = 0,
                                        mzrange. = NULL)
    brks <- pMat$breaks
    pMat <- pMat$profMat  ## rows are masses, cols are retention times/scans.
    bin_size <- diff(brks[c(1,2)])
    bin_half <- bin_size / 2
    ## Calculate the mean mass per bin using the breaks used for the binning.
    ## Note: these define the real mass breaks as they have been used for the
    ## binning. Simply using seq(floor...) as in the original code is wrong
    ## because the mass bins are calculated wrongly. The bin size is != step,
    ## bin size is marginally smaller and, for larger mz the correct mass
    ## bin will be wrongly identified.
    mass <- brks[-length(brks)] + bin_half ## midpoint for the breaks
    mass_range <- range(mass)

    ## Prepare the result matrix.
    cnames <- c("mz", "mzmin", "mzmax", "rt", "rtmin", "rtmax", "into", "maxo")
    rmat <- matrix(nrow = nrow(peakrange), ncol = length(cnames))
    colnames(rmat) <- cnames

    for (i in order(peakrange[, 1])) {

        if (length(stime) == 1) {
            stime_temp <- stime[[1]]
        } else {
            message("Feature-wise warpping function:", naidx[i])
            stime_temp <- stime[[naidx[i]]]
        }

        imz <- xcms:::findRange(mass, c(peakrange[i, 1] - bin_half,
                                        peakrange[i, 2] + bin_half), TRUE)
        iret <- xcms:::findRange(stime_temp, peakrange[i, 3:4], TRUE)
        idx_imz <- imz[1]:imz[2]
        idx_iret <- iret[1]:iret[2]
        ## Extract the intensity matrix for the mz-rt range: rows are mz, cols
        ## rt values.
        ymat <- pMat[idx_imz, idx_iret, drop = FALSE]
        ## Define the maximum intensity, is one value per mz.
        ymax <- xcms:::colMax(ymat)
        iymax <- which.max(ymax)

        ## The width in rt.
        pwid <- diff(stime_temp[iret])/diff(iret)

        ## Calculate sum across rt. For each mz we get one value.
        rosm <- rowSums(ymat)
        limz <- length(idx_imz)
        if (length(rosm) != limz) { ## that happens for some reason
            warning("weighted.mean  : x and w must have the same length \n")
            rosm <- rep(1, limz)  ## fallback to mean
        }
        ## mean mz:
        rmat[i, 1] <- weighted.mean(mass[idx_imz], rosm) ## mz; its not the
        ## position of the largest intensity!
        if (is.nan(rmat[i,1]) || is.na(rmat[i,1])) ##  R2.11 :  weighted.mean()
            ## results in NA (not NaN) for zero weights
            rmat[i, 1] <- mean(peakrange[i, c(1,2)])

        rmat[i, 2:3] <- peakrange[i, c(1,2)]            ## mzmin, mzmax
        rmat[i, 4] <- stime_temp[idx_iret][iymax] ## rt
        rmat[i, 5:6] <- peakrange[i, c(3,4)]            ## rtmin, rtmax

        if (peakrange[i, 3] <  stime_temp[1] ||
            peakrange[i, 4] > stime_temp[length(stime_temp)] ||
            is.nan(pwid)) {
            warning("getPeaks: Peak  m/z:", peakrange[i, 1], "-",
                    peakrange[i, 2], ",  RT:", peakrange[i, 3], "-",
                    peakrange[i, 4], "is out of retention time range for ",
                    "this sample (", object@filepath,
                    "), using zero intensity value.\n")
            rmat[i, 7:8] <- 0
        } else {
            rmat[i, 7] <- pwid * sum(ymax)  ## into
            rmat[i, 8] <- ymax[iymax]       ## maxo
        }
    }
    invisible(rmat)
}

#' Load sample profiles for each peak group
#'
#' This function loads each raw sample profiles from the file with certain m/z
#' and RT range.
#' @param filePaths The character vector of the loading file paths.
#' @param excluGroups The output matrix of \code{\link{misalignDetect}} or
#'   \code{\link[xcms]{xcmsSet-class}}$\code{group}, in which \code{mzmin},
#'   \code{mzmax}, \code{rtmin}, and \code{rtmax} are set as the m/z and RT
#'   range for loading.
#' @param mzAdd The extra m/z range for loading (both sides), and the default is
#'   0.005.
#' @param rtAdd The extra RT range for loading (both sides), and the default is
#'   10 (seconds).
#' @param profstep The size of each m/z bin for peak integration, and the
#'   default is 0.
#' @param BPPARAM A object of \pkg{BiocParallel} to control parallel processing,
#'   and can be created by
#'   \code{\link[BiocParallel:SerialParam-class]{SerialParam}},
#'   \code{\link[BiocParallel:MulticoreParam-class]{MulticoreParam}}, or
#'   \code{\link[BiocParallel:SnowParam-class]{SnowParam}}.
#'
#' @details This function obtains the extracted ion chromatogram for each sample
#' at the givin m/z and RT range with a certain m/z bin size for integration.
#' Considering there may be missing peak by peak detection, \code{mzAdd} and
#' \code{rtAdd} are to increase the integration range.
#' @return A list of the same length as the row number of \code{excluGroups}, in
#' which each element is a \code{\link{ncGTWinput}} object.
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#' xcmsSmallWin <- xcmsExamples$xcmsSmallWin
#' ppm <- xcmsExamples$ppm
#'
#' # detect misaligned features
#' excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
#'
#' # obtain the paths of the sample files
#' filepath <- system.file("extdata", package = "ncGTW")
#' file <- list.files(filepath, pattern="mzxml", full.names=TRUE)
#'
#' tempInd <- matrix(0, length(file), 1)
#' for (n in seq_along(file)){
#'     tempCha <- file[n]
#'     tempLen <- nchar(tempCha)
#'     tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
#'         tempLen - 6))
#' }
#' # sort the paths by data acquisition order
#' file <- file[sort.int(tempInd, index.return = TRUE)$ix]
#'
#' # load the sample profiles
#' ncGTWinputs <- loadProfile(file, excluGroups)
#' @export

loadProfile <- function(filePaths, excluGroups, mzAdd=0.005, rtAdd=10,
                        profstep=0, BPPARAM=BiocParallel::SnowParam(workers=1)){

    if (!is.character(filePaths))
        stop('the \'filePaths\' argument should be a character vector')
    if (!is.numeric(excluGroups))
        stop('the \'excluGroups\' argument should be a numeric matrix')
    cName <- c("mzmed", "mzmin", "mzmax", "rtmed", "rtmin", "rtmax")
    if (!all(cName %in% colnames(excluGroups)))
        stop('the \'excluGroups\' argument should contain column names:
            "mzmed", "mzmin", "mzmax","rtmed", "rtmin", "rtmax"')


    groupNum <- dim(excluGroups)[1]
    fileNum <- length(filePaths)

    mzRange <- excluGroups[,c('mzmin', 'mzmax'), drop=FALSE]
    mzRange[,'mzmin'] <- mzRange[,'mzmin'] - mzAdd
    mzRange[,'mzmax'] <- mzRange[,'mzmax'] + mzAdd
    rtRange <- excluGroups[,c('rtmin', 'rtmax'), drop=FALSE]
    rtRange[,'rtmin'] <- rtRange[,'rtmin'] - rtAdd
    rtRange[,'rtmax'] <- rtRange[,'rtmax'] + rtAdd


    timeS <- Sys.time()
    eicList <-
        suppressWarnings(
            BiocParallel::bplapply(filePaths, loadEic, mzRange,
                rtRange, profstep, BPPARAM=BPPARAM))
    timeE <- Sys.time()
    timeDif <- timeE - timeS
    message('The loading time is ',round(timeDif,2), ' ', units(timeDif), '.')
    message('Starting to check the length of each profile...')

    groupProf <- vector("list", groupNum)
    groupRt <- vector("list", groupNum)
    if ('index' %in% colnames(excluGroups)){
        groupInd <- excluGroups[, 'index']
    } else{
        groupInd <- seq_len(nrow(excluGroups))
    }
    names(groupProf) <- paste0('group', groupInd)
    names(groupRt) <- names(groupProf)

    maxMinArr <- array(0, c(groupNum, fileNum, 2))
    maxMinMat <- matrix(0, groupNum, 2)
    maxMinMat <- matrix(0, groupNum, 2)
    maxMinInd <- array(0, c(groupNum, fileNum, 2))

    LenMat <- matrix(0, groupNum, fileNum)
    LenVec <- matrix(0, groupNum, 1)

    ncGTWinputs <- vector('list', groupNum)
    for (i in seq_len(groupNum)){
        for (j in seq_len(fileNum)){
            maxMinArr[i, j, 1] <- min(eicList[[j]][[i]][,1])
            maxMinArr[i, j, 2] <- max(eicList[[j]][[i]][,1])
        }
        maxMinMat[i, 1] <- max(maxMinArr[i, , 1, drop=FALSE])
        maxMinMat[i, 2] <- min(maxMinArr[i, , 2, drop=FALSE])

        for (j in seq_len(fileNum)){
            maxMinInd[i, j, 1] <-
                which.min(abs(eicList[[j]][[i]][, 1] - maxMinMat[i, 1]))
            maxMinInd[i, j, 2] <-
                which.min(abs(eicList[[j]][[i]][, 1] - maxMinMat[i, 2]))
            LenMat[i, j] <- maxMinInd[i, j, 2] - maxMinInd[i, j, 1] + 1
        }

        if (length(unique(LenMat[i,])) != 1){
            warning('The RT resolution may not be same for some samples...')
            LenVec[i] <- min(LenMat[i,])
        } else{
            LenVec[i] <- unique(LenMat[i,])
        }

        groupProf[[i]] <- matrix(0, fileNum, LenVec[i])
        groupRt[[i]] <- matrix(0, fileNum, LenVec[i])
        for (j in seq_len(fileNum)){
            rtProf <- eicList[[j]][[i]][maxMinInd[i, j, 1]:
                (maxMinInd[i, j, 1] + LenVec[i] - 1), ]
            groupRt[[i]][j, ] <- rtProf[ , 1]
            groupProf[[i]][j, ] <- rtProf[ , 2]
        }

        groupInfo <- excluGroups[i, ]
        if (!'index' %in% names(groupInfo))
            groupInfo <- c(index=i, groupInfo)
        ncGTWinputs[[i]] <- new("ncGTWinput", groupInfo=groupInfo,
                                profiles=groupProf[[i]], rtRaw=groupRt[[i]])

    }
    return(ncGTWinputs)
}



loadEic <- function(filePath, mzRange, rtRange, profstep){

    rawProf <- suppressMessages(xcmsRaw(filePath, 0))

    rawEic <- vector('list', dim(mzRange)[1])

    for (n in seq_len(dim(mzRange)[1])){
        tempEic <- xcms::rawEIC(rawProf, mzRange[n, ], rtRange[n, ])
        rawEic[[n]] <- cbind(tempEic$scan, tempEic$intensity)
    }

    rm(rawProf)

    gc()

    return(rawEic)
}

#' Plot profiles for each peak group
#'
#' This function plots sample profiles with loaded information.
#' @param ncGTWinput An object return by \code{\link{loadProfile}} of sample
#'   profiles for plotting.
#' @param sampleRt A list of the same length as the sample number in which each
#'   element is a vector corresponding to the sample raw/adjusted RT for
#'   plotting.
#' @param sampleInd Indicate which samples should be plotted, and the default is
#'   \code{1:dim(ncGTWinput$rtRaw)[1]}.
#' @param ind A user defined index, and the default is \code{NULL}.
#' @param savePath The path to save the plots, and the default is \code{NULL}
#'   (do not save anything).
#' @param show Show the plot in R or not, and the default is \code{TRUE}.
#' @param sub Show more information on the plot or not, and the default is
#'   \code{TRUE}.
#' @param filter Apply a Gaussian filter for demonstration or not, and the
#'   default is \code{FALSE}.
#'
#' @details This function plots the extracted ion chromatogram obtained by
#' \code{\link{loadProfile}}. The user can decide to save the figure, show the
#' figure, or apply a Gaussian filter on the data by parameter setting.
#' @return A plot to the current device.
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#' xcmsSmallWin <- xcmsExamples$xcmsSmallWin
#' ppm <- xcmsExamples$ppm
#'
#' # detect misaligned features
#' excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
#'
#' # obtain the paths of the sample files
#' filepath <- system.file("extdata", package = "ncGTW")
#' file <- list.files(filepath, pattern="mzxml", full.names=TRUE)
#'
#' tempInd <- matrix(0, length(file), 1)
#' for (n in seq_along(file)){
#'     tempCha <- file[n]
#'     tempLen <- nchar(tempCha)
#'     tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
#'         tempLen - 6))
#' }
#' # sort the paths by data acquisition order
#' file <- file[sort.int(tempInd, index.return = TRUE)$ix]
#'
#' # load the sample profiles
#' ncGTWinputs <- loadProfile(file, excluGroups)
#'
#' # plot all loaded features
#' for (n in seq_along(ncGTWinputs))
#'     plotGroup(ncGTWinputs[[n]], slot(xcmsLargeWin, 'rt')$corrected)
#' @export

plotGroup <-
    function(ncGTWinput, sampleRt, sampleInd=seq_len(dim(ncGTWinput@rtRaw)[1]),
        ind=NULL, savePath=NULL, show=TRUE, sub=TRUE, filter=FALSE){
    samNum <- dim(ncGTWinput@rtRaw)[1]
    profiles <- ncGTWinput@profiles
    if (filter)
        for (n in seq_len(samNum))
            profiles[n, ] <- gaussFilter(profiles[n, ])

    rtRange <- matrix(0, samNum, dim(ncGTWinput@rtRaw)[2])
    for (n in seq_len(samNum))
        rtRange[n, ] <- sampleRt[[n]][ncGTWinput@rtRaw[n, ]]

    colVec <- matrix(0, samNum, 1)
    for (n in seq_len(dim(colVec)[1]))
        colVec[n] <- rgb(n / samNum, 1 - n / samNum,
            abs(samNum / 2 - abs(n - samNum / 2)) / (samNum / 2))

    mzmed <- round(ncGTWinput@groupInfo['mzmed'], 2)
    groupInd <- ncGTWinput@groupInfo['index']
    tit <- paste("Extracted Ion Chromatogram:", mzmed, "m/z")
    if (!is.null(ind)){
        subt <- paste0("Group ", groupInd, " (", ind, ")",
            "   Color: Green -> Purple -> Red")
    } else{
        subt <- paste0("Group ", groupInd,"   Color: Green -> Purple -> Red")
    }

    if (show){
        matplot(t(rtRange[sampleInd, , drop=FALSE]),
                t(profiles[sampleInd, , drop=FALSE]),
                type='l', col=colVec[sampleInd], lty=1,
                xlab="rt (seconds)", ylab="Intensity")
        if (sub){
            title(main=paste("Extracted Ion Chromatogram:", mzmed, "m/z"),
                sub=subt)
        } else{
            title(main=paste("Extracted Ion Chromatogram:", mzmed, "m/z"))
        }
    }
    if (length(savePath) != 0){
        if (substr(savePath, nchar(savePath), nchar(savePath)) != '/')
            savePath <- paste0(savePath, '/')
        if (ind){
            filePath <- paste0(savePath, "group", groupInd, "_", ind, ".png")
        } else{
            filePath <- paste0(savePath, "group", groupInd, ".png")
        }
        png(filename=filePath, width=1080, height=720)
        matplot(t(rtRange[sampleInd, , drop=FALSE]),
            t(profiles[sampleInd, , drop = FALSE]),
                type='l', col=colVec[sampleInd], lty=1,
                xlab="rt (seconds)", ylab="Intensity")
        if (sub){
            title(main = paste("Extracted Ion Chromatogram:", mzmed, "m/z"),
                sub = subt)
        } else{
            title(main = paste("Extracted Ion Chromatogram:", mzmed, "m/z"))
        }
        dev.off()
    }
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

graphCut <- function(termW, edges) {
    .Call('_ncGTW_graphCut', PACKAGE = 'ncGTW', termW, edges)
}

#' Adjust retention time
#'
#' This function produces the new warping functions (RT lists) with the
#' realignment result.
#' @param xcmsLargeWin A \code{\link[xcms]{xcmsSet-class}} object.
#' @param ncGTWinput A \code{\link{ncGTWinput}} object.
#' @param ncGTWoutput A \code{\link{ncGTWoutput}} object.
#' @param ppm Should be set as same as the one when performing the peak
#'   detection function in \code{xcms}.
#' @details This function produces the new warping functions (RT lists) with the
#' realignment result.
#' @return A \code{\link{ncGTWwarp}} object.
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#' xcmsSmallWin <- xcmsExamples$xcmsSmallWin
#' ppm <- xcmsExamples$ppm
#'
#' # detect misaligned features
#' excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
#'
#' # obtain the paths of the sample files
#' filepath <- system.file("extdata", package = "ncGTW")
#' file <- list.files(filepath, pattern="mzxml", full.names=TRUE)
#'
#' tempInd <- matrix(0, length(file), 1)
#' for (n in seq_along(file)){
#'     tempCha <- file[n]
#'     tempLen <- nchar(tempCha)
#'     tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
#'         tempLen - 6))
#' }
#' # sort the paths by data acquisition order
#' file <- file[sort.int(tempInd, index.return = TRUE)$ix]
#' \dontrun{
#' # load the sample profiles
#' ncGTWinputs <- loadProfile(file, excluGroups)
#'
#' # initialize the parameters of ncGTW alignment with default
#' ncGTWparam <- new("ncGTWparam")
#'
#' # run ncGTW alignment
#' ncGTWoutputs <- vector('list', length(ncGTWinputs))
#' for (n in seq_along(ncGTWinputs))
#'     ncGTWoutputs[[n]] <- ncGTWalign(ncGTWinputs[[n]], xcmsLargeWin, 5,
#'         ncGTWparam = ncGTWparam)
#'
#' # adjust RT with the realignment results from ncGTW
#' ncGTWres <- xcmsLargeWin
#' ncGTWRt <- vector('list', length(ncGTWinputs))
#' for (n in seq_along(ncGTWinputs)){
#'     adjustRes <- adjustRT(ncGTWres, ncGTWinputs[[n]], ncGTWoutputs[[n]], ppm)
#'     xcms::peaks(ncGTWres) <- ncGTWpeaks(adjustRes)
#'     ncGTWRt[[n]] <- rtncGTW(adjustRes)
#' }
#'
#' # apply the adjusted RT to a xcmsSet object
#' xcms::groups(ncGTWres) <- excluGroups[ , 2:9]
#' xcms::groupidx(ncGTWres) <- xcms::groupidx(xcmsLargeWin)[excluGroups[ , 1]]
#' rtCor <- vector('list', length(xcms::filepaths(ncGTWres)))
#' for (n in seq_along(file)){
#'     rtCor[[n]] <- vector('list', dim(excluGroups)[1])
#'     for (m in seq_len(dim(excluGroups)[1]))
#'         rtCor[[n]][[m]] <- ncGTWRt[[m]][[n]]
#' }
#' slot(ncGTWres, 'rt')$corrected <- rtCor
#' }
#' @export

adjustRT <- function(xcmsLargeWin, ncGTWinput, ncGTWoutput, ppm){
    if (!is(xcmsLargeWin, 'xcmsSet'))
        stop('xcmsLargeWin should be a "xcmsSet" object.')
    if (!is(ncGTWinput, 'ncGTWinput'))
        stop('ncGTWinput should be a "ncGTWinput" object.')
    if (!is(ncGTWoutput, 'ncGTWoutput'))
        stop('ncGTWoutput should be a "ncGTWoutput" object.')
    if (ppm <= 0)
        stop('ppm should be larger than 0.')

    peaks <- xcmsLargeWin@peaks
    groupInfo <- ncGTWinput@groupInfo
    groupInd <- groupInfo['index']
    rtXCMS <- xcmsLargeWin@rt$corrected
    rtRaw <- xcmsLargeWin@rt$raw
    scanRangeOld <- ncGTWinput@rtRaw
    dataOri <- ncGTWinput@profiles
    data <- ncGTWoutput@alignData
    path <- ncGTWoutput@ncGTWpath
    scanRange <- ncGTWoutput@scanRange
    downSample <- ncGTWoutput@downSample

    ## Find unique peaks
    XCMSPeaks <- findUniPeak(peaks, groupInd, xcmsLargeWin@groupidx, ppm)

    ## Find the maximum number of peaks within a sample
    sampleCount <- table(XCMSPeaks[ , 'sample'])
    groupNum <- max(sampleCount)

    ## Find corresponding scan and RT between XCMS and ncGTW
    ncGTWpeaks <- XCMSPeaks
    ncGTWpeaks[ , c('rt', 'rtmin', 'rtmax')] <- 0
    peakScanRt <- matrix(0, dim(ncGTWpeaks)[1], 11)
    colnames(peakScanRt) <-
        c('scan_XCMS', 'scan_ncGTW', 'subscan_ncGTW', 'rt_ncGTW',
            'scanmin_XCMS', 'scanmin_ncGTW', 'rtmin_ncGTW',
            'scanmax_XCMS', 'scanmax_ncGTW', 'rtmax_ncGTW', 'sample')

    warpOrder <-
        sort(XCMSPeaks[ , 'maxo'], index.return = TRUE, decreasing = TRUE)$ix
    for (nn in seq_len(dim(ncGTWpeaks)[1])){
        n <- warpOrder[nn]
        samInd <- XCMSPeaks[n, 'sample']
        samPath <- path[[samInd]]
        samRtXCMS <- rtXCMS[[samInd]][scanRange[samInd, ]]
        samRtXCMSOld <- rtXCMS[[samInd]][scanRangeOld[samInd, ]]
        samRtRaw <- rtRaw[[samInd]][scanRange[samInd, ]]
        samRtRawOld <- rtRaw[[samInd]][scanRangeOld[samInd, ]]
        meanDif <- mean(diff(samRtXCMSOld))

        ### Find the true apex points
        fRange <- round(1 / meanDif)
        scanXCMS <- rt2scan(XCMSPeaks[n, 'rt'], samRtXCMSOld)
        scanXCMSrange <- max(1, (scanXCMS - fRange)) :
            min(length(samRtXCMSOld), (scanXCMS + fRange))

        rE <- scanXCMSrange[length(scanXCMSrange)]
        for (rangeInd in seq_len(fRange)){
            ind <- scanXCMS + rangeInd
            if (ind > length(samRtXCMSOld))
                break
            if (samRtXCMSOld[ind] - samRtXCMSOld[ind - 1] > 2 * meanDif){
                rE <- ind - 1
                break
            }
        }
        rS <- scanXCMSrange[1]
        for (rangeInd in seq_len(fRange)){
            ind <- scanXCMS - rangeInd
            if (ind < 1)
                break
            if (samRtXCMSOld[ind + 1] - samRtXCMSOld[ind] > 2 * meanDif){
                rS <- ind + 1
                break
            }
        }
        scanXCMSrange <- rS:rE

        scanXCMS <- scanXCMSrange[which.max(dataOri[samInd, scanXCMSrange])]
        XCMSrt <- samRtXCMSOld[scanXCMS]
        scanSubXCMS <- rt2scan(XCMSrt, samRtXCMS)

        ### Match the apex point
        scanSubncGTW <-
            round(mean(samPath[which(samPath[ ,2] == scanSubXCMS), 1]))
        scanncGTW <- (scanSubncGTW - 1) * downSample
        if (scanncGTW > dim(scanRangeOld)[2])
            scanncGTW <- dim(scanRangeOld)[2]
        if (scanncGTW < 1)
            scanncGTW <- 1
        ncGTWrt <- rtRaw[[samInd]][scanRangeOld[samInd, scanncGTW]]

        peakScanRt[n, 'rt_ncGTW'] <- ncGTWrt
        peakScanRt[n, 'subscan_ncGTW'] <- scanSubncGTW
        peakScanRt[n, 'scan_XCMS'] <-
            which(scanRangeOld[samInd, ] == scanRange[samInd, scanSubXCMS])
        peakScanRt[n, 'scan_ncGTW'] <- scanncGTW

        ### Avoid overlapping apex points
        samPeaks <-
            cbind(peakScanRt[peakScanRt[ , 'sample'] == samInd, , drop=FALSE],
                peakInd=which(peakScanRt[ , 'sample'] == samInd))

        for (m in seq_len(dim(samPeaks)[1])){
            tempInd <- samPeaks[m, 'peakInd']
            apexDif <- XCMSPeaks[n, 'rt'] - XCMSPeaks[tempInd, 'rt']
            tempSign <- apexDif / abs(apexDif)

            if (apexDif > 0){
                widthDif <- XCMSPeaks[n, 'rt'] - XCMSPeaks[n, 'rtmin'] +
                    XCMSPeaks[tempInd, 'rtmax'] - XCMSPeaks[tempInd, 'rt']
            } else{
                widthDif <- XCMSPeaks[n, 'rtmax'] - XCMSPeaks[n, 'rt'] +
                    XCMSPeaks[tempInd, 'rt'] - XCMSPeaks[tempInd, 'rtmin']
            }
            peakRtDif <- min(abs(apexDif), widthDif)

            if (tempSign * (peakScanRt[n, 'rt_ncGTW'] - samPeaks[m, 'rt_ncGTW'])
                < peakRtDif){
                peakScanRt[n, 'scan_ncGTW'] <-
                    rt2scan(samPeaks[m, 'rt_ncGTW'] +
                                tempSign * peakRtDif, samRtXCMSOld)
                peakScanRt[n, 'rt_ncGTW'] <-
                    samRtRawOld[peakScanRt[n, 'scan_ncGTW']]
            }
        }

        ### Match the start and end points
        peakScanRt[n, 'rtmin_ncGTW'] <-
            XCMSPeaks[n, 'rtmin'] - XCMSPeaks[n, 'rt'] +
            peakScanRt[n, 'rt_ncGTW']
        peakScanRt[n, 'rtmax_ncGTW'] <-
            XCMSPeaks[n, 'rtmax'] - XCMSPeaks[n, 'rt'] +
            peakScanRt[n, 'rt_ncGTW']
        peakScanRt[n, 'scanmin_ncGTW'] <-
            rt2scan(peakScanRt[n, 'rtmin_ncGTW'], samRtRawOld)
        peakScanRt[n, 'scanmax_ncGTW'] <-
            rt2scan(peakScanRt[n, 'rtmax_ncGTW'], samRtRawOld)
        peakScanRt[n, 'scanmin_XCMS'] <- peakScanRt[n, 'scanmin_ncGTW'] -
            peakScanRt[n, 'scan_ncGTW'] + peakScanRt[n, 'scan_XCMS']
        peakScanRt[n, 'scanmax_XCMS'] <- peakScanRt[n, 'scanmax_ncGTW'] -
            peakScanRt[n, 'scan_ncGTW'] + peakScanRt[n, 'scan_XCMS']
        peakScanRt[n, 'sample'] <- XCMSPeaks[n, 'sample']

        ncGTWpeaks[n, c('rt', 'rtmin', 'rtmax')] <-
            peakScanRt[n, c('rt_ncGTW', 'rtmin_ncGTW', 'rtmax_ncGTW')]
        peaks[ncGTWpeaks[n, 'peakInd'], c('rt', 'rtmin', 'rtmax')] <-
            ncGTWpeaks[n, c('rt', 'rtmin', 'rtmax')]

    }

    ## Find a sample as the center for kmeans
    groupSam <- as.numeric(names(which(sampleCount == groupNum)))
    maxNum <- 0
    maxRange <- 0
    maxInd <- 1
    for (ind in seq_len(length(groupSam))){
        samPeaks <- XCMSPeaks[XCMSPeaks[ , 'sample'] == groupSam[ind], 'rt']
        tempNum <- length(samPeaks)
        if (tempNum < maxNum )
            next
        tempRange <- max(samPeaks) - min(samPeaks)
        if (tempNum > maxNum ){
            maxNum <- tempNum
            maxRange <- tempRange
            maxInd <- groupSam[ind]
        } else if (tempRange > maxRange){
            maxRange <- tempRange
            maxInd <- groupSam[ind]
        }
    }
    groupSam <- maxInd


    ## kmeans grouping
    cenInd <- which(peakScanRt[ , 'sample'] == groupSam)
    kcenter <- peakScanRt[cenInd, 'rt_ncGTW', drop=FALSE]

    intOrder <- sort(XCMSPeaks[cenInd, 'maxo'],
                    index.return=TRUE, decreasing=TRUE)$ix[seq_len(groupNum)]
    kcenter <- kcenter[intOrder, , drop=FALSE]
    kcenter <- unique(kcenter)
    groupNum <- length(kcenter)


    if (length(kcenter) == 1){
        kmeansncGTW <- kmeans(peakScanRt[ , 'rt_ncGTW', drop=FALSE], 1)
    } else{
        kmeansncGTW <- kmeans(peakScanRt[ , 'rt_ncGTW', drop=FALSE], kcenter)
    }

    ## Put peaks into their groups
    peakGroup <- vector('list', groupNum)
    tempPeaks <- matrix(NA, max(peaks[ , 'sample']), dim(peakScanRt)[2] + 2)
    colnames(tempPeaks) <- c(colnames(peakScanRt), 'detect', 'maxo')
    colnames(tempPeaks)[c(1, 5, 8)] <-
        c('scan_Raw', 'scanmin_Raw', 'scanmax_Raw')
    for (n in seq_len(groupNum))
        peakGroup[[n]] <- tempPeaks

    for (n in seq_len(dim(peakScanRt)[1])){
        gInd <- kmeansncGTW$cluster[n]
        sInd <- peakScanRt[n, 'sample']

        if (is.na(peakGroup[[gInd]][sInd, 1]) ||
            (XCMSPeaks[n, 'maxo'] > peakGroup[[gInd]][sInd, 'maxo'])){

            peakGroup[[gInd]][sInd, ] <-
                c(peakScanRt[n, ], 1, XCMSPeaks[n, 'maxo'])
        }
    }

    ## Remove groups with too few samples
    rmInd <- matrix(TRUE, length(peakGroup), 1)
    for (n in seq_len(groupNum)){
        tempPeaks <- peakGroup[[n]]
        #        if (sum(is.na(tempPeaks[,1])) > dim(tempPeaks)[1] * (3 / 4) )
        if (sum(!is.na(tempPeaks[,1])) <
            sum(groupInfo[9:length(groupInfo)]) * (1 / 4) )
            rmInd[n] <- FALSE
    }
    peakGroup <- peakGroup[rmInd]
    groupNum <- length(peakGroup)
    peakGroupMed <- tempPeaks[seq_len(groupNum), , drop = FALSE]
    for (n in seq_len(groupNum))
        for (m in seq_len(dim(peakGroupMed)[2]))
            peakGroupMed[n, m] <- median(peakGroup[[n]][ , m], TRUE)

    ## Fill in missing peaks for each group
    tempLabel <- c('scan_ncGTW', 'rt_ncGTW', 'subscan_ncGTW','scanmin_ncGTW',
                    'rtmin_ncGTW', 'scanmax_ncGTW', 'rtmax_ncGTW')
    for (n in seq_len(groupNum)){
        tempPeaks <- peakGroup[[n]]
        for (m in seq_len(dim(tempPeaks)[1])){
            if (!is.na(tempPeaks[m, 1]))
                next

            tempPeaks[m , tempLabel] <- peakGroupMed[n, tempLabel]
            samPath <- path[[m]]
            apexInd <- samPath[which(samPath[ , 1] ==
                round(peakGroupMed[n, 'subscan_ncGTW'])), 2]

            apexInd <- apexInd[which.max(data[m, apexInd])]

            tempPeaks[m, 'scan_Raw'] <-
                which(scanRangeOld[m, ] == scanRange[m, apexInd])
            tempPeaks[m, 'scanmin_Raw'] <- peakGroupMed[n, 'scanmin_ncGTW'] +
                tempPeaks[m, 'scan_Raw'] - peakGroupMed[n, 'scan_ncGTW']
            tempPeaks[m, 'scanmax_Raw'] <- peakGroupMed[n, 'scanmax_ncGTW']+
                tempPeaks[m, 'scan_Raw'] - peakGroupMed[n, 'scan_ncGTW']
            tempPeaks[m, 'sample'] <- m
        }
        peakGroup[[n]] <- tempPeaks
    }


    ##  Warp RT of peaks of each samples
    rtncGTW <- rtXCMS
    rtncGTWsub <- scanRangeOld * NA
    rtRawSub <- scanRangeOld * NA
    for (n in seq_len(length(rtRaw)))
        rtRawSub[n, ] <- rtRaw[[n]][scanRangeOld[n, ]]

    tempShift <- 5
    while (any(t(diff(t(rtRawSub))) > 5)){
        for (n in seq_along(rtRaw)){
            rtRawSub[n, ] <- rtRaw[[n]][scanRangeOld[n, ] - tempShift]
        }
        tempShift <- tempShift + 5
    }

    for (n in seq_len(groupNum)){
        tempPeaks <- peakGroup[[n]]
        for (m in seq_len(dim(tempPeaks)[1])){
            rawSta <- tempPeaks[m, 'scanmin_Raw']
            rawEnd <- tempPeaks[m, 'scanmax_Raw']
            ncGTWSta <- tempPeaks[m, 'scanmin_ncGTW']
            ncGTWEnd <- tempPeaks[m, 'scanmax_ncGTW']

            if (rawEnd > dim(scanRangeOld)[2]){
                ncGTWEnd <- ncGTWEnd - (rawEnd - dim(scanRangeOld)[2])
                rawEnd <- dim(scanRangeOld)[2]
            }
            if (ncGTWEnd > dim(rtRawSub)[2]){
                rawEnd <- rawEnd - (ncGTWEnd - dim(rtRawSub)[2])
                ncGTWEnd <- dim(rtRawSub)[2]
            }
            if (rawSta < 1){
                ncGTWSta <- ncGTWSta + (1 - rawSta)
                rawSta <- 1
            }
            rawInd <- rawSta:rawEnd
            overlapFlag <- !is.na(rtncGTWsub[m, rawInd])
            rtncGTWsub[m, rawInd] <- rtRawSub[m, ncGTWSta:ncGTWEnd]
            if (sum(overlapFlag) == 0)
                next

            ### Solve overlapping peaks
            olInd <- which(overlapFlag)
            olSta <- rawInd[olInd[1]] - 1
            if (olSta == 0)
                olSta <- 1
            olEnd <- rawInd[olInd[length(olInd)]] + 1
            if (olEnd > dim(scanRangeOld)[2])
                olEnd <- dim(scanRangeOld)[2]
            while (is.na(rtncGTWsub[m, olSta]))
                olSta <- olSta + 1
            while (is.na(rtncGTWsub[m, olEnd]))
                olEnd <- olEnd - 1

            while (rtncGTWsub[m, olSta] > rtncGTWsub[m, olEnd]){
                olStaOld <- olSta
                olEndOld <- olEnd
                if ((olSta - 1 > 0) && !is.na(rtncGTWsub[m, olSta - 1]))
                    olSta <- olSta - 1

                if ((olEnd + 1 < dim(rtncGTWsub)[2]) &&
                    !is.na(rtncGTWsub[m, olEnd + 1]))
                    olEnd <- olEnd + 1

                if (olSta == 0)
                    olSta <- 1
                if (olEnd > dim(scanRangeOld)[2])
                    olEnd <- dim(scanRangeOld)[2]
                if (olStaOld == olSta && olEndOld == olEnd){
                    temp <- rtncGTWsub[m, olSta]
                    rtncGTWsub[m, olSta] <- rtncGTWsub[m, olEnd]
                    rtncGTWsub[m, olEnd] <- temp
                }
            }
            rtncGTWsub[m, olSta:olEnd] <- approx(c(olSta, olEnd),
                rtncGTWsub[m, c(olSta, olEnd)], n = length(olSta:olEnd))$y

        }
    }

    ## Filling non-peak part of each sample
    for (n in seq_len(dim(rtncGTWsub)[1])){
        while (!is.na(which(is.na(rtncGTWsub[n, ]))[1])){
            ipSta <- which(is.na(rtncGTWsub[n, ]))[1]
            ipEnd <- which(!is.na(rtncGTWsub[n, ipSta:dim(rtncGTWsub)[2]]))[1]
            if (is.na(ipEnd)){
                ipEnd <- dim(rtncGTWsub)[2]
            } else {
                ipEnd <- ipEnd + ipSta - 2
            }

            if (ipSta == 1){
                ipStaRt <- rtncGTW[[n]][max(scanRangeOld[n, ipSta] - 1, 1)]
            } else{
                ipStaRt <- rtncGTWsub[n, ipSta - 1]
            }

            if (ipEnd == dim(rtncGTWsub)[2]){
                tempEnd <- min(length(rtncGTW[[n]]), scanRangeOld[n, ipEnd] + 1)
                ipEndRt <- rtncGTW[[n]][tempEnd]
            } else{
                ipEndRt <- rtncGTWsub[n, ipEnd + 1]
            }

            if (ipStaRt > ipEndRt){
                tempDif <- median(diff(rtncGTW[[n]]))
                if (ipSta == 1){
                    ipStaRt <- ipEndRt - (ipEnd - ipSta) * tempDif
                } else{
                    ipEndRt <- ipStaRt + (ipEnd - ipSta) * tempDif
                }
            }
            ipRt <- approx(c(ipSta - 1, ipEnd + 1), c(ipStaRt, ipEndRt),
                            n = length((ipSta - 1):(ipEnd + 1)))$y
            rtncGTWsub[n, ipSta:ipEnd] <- ipRt[2:(length(ipRt) - 1)]
        }
    }

    ## Fix decreasing RT
    for (n in seq_len(dim(rtncGTWsub)[1])){
        for (m in 2:dim(rtncGTWsub)[2]){
            if (rtncGTWsub[n, m] >= rtncGTWsub[n, m - 1])
                next

            pl <- m - 1
            pr <- m
            while (rtncGTWsub[n, pl] > rtncGTWsub[n, pr]){
                if (pl > 1)
                    pl <- pl - 1
                if (pr < dim(rtncGTWsub)[2])
                    pr <- pr + 1
            }
            rtncGTWsub[n, pl:pr] <- approx(c(pl, pr),
                rtncGTWsub[n, c(pl, pl)], n = length(pl:pr))$y
        }
    }
    for (n in seq_len(dim(rtncGTWsub)[1]))
        rtncGTW[[n]][scanRangeOld[n,]] <- rtncGTWsub[n, ]

    return(new("ncGTWwarp", rtncGTW=rtncGTW, ncGTWpeaks=peaks))
}


findUniPeak <- function(peaks, groupInd, groupidx, ppm=1e6, sampleInd=NULL){
    ppm <- ppm / 1e6

    Peaks <- cbind(peaks[groupidx[[groupInd]], ],
        peakInd=groupidx[[groupInd]])
    if (!is.null(sampleInd))
        Peaks <- Peaks[is.element(Peaks[ , 'sample'], sampleInd), , drop=FALSE]

    if (dim(Peaks)[1] == 0)
        return(Peaks)

    tempInd <- sort(Peaks[ , 'maxo'], index.return = TRUE, decreasing = TRUE)$ix
    Peaks <- Peaks[tempInd, , drop = FALSE]
    Peaks <- Peaks[!duplicated(Peaks[,c('rt', 'sample'), drop = FALSE]), , drop = FALSE]
    tempInd <- sort(Peaks[ , 'peakInd'], index.return = TRUE)$ix
    Peaks <- Peaks[tempInd, , drop = FALSE]

    rmInd <- matrix(TRUE, dim(Peaks)[1], 1)

    for (n in seq_len(dim(Peaks)[1] - 1)){
        if (rmInd[n] == FALSE)
            next
        if (abs(Peaks[n, 'rtmax'] - Peaks[n, 'rtmin']) > 30){
            rmInd[n] <- FALSE
            next
        }
        samPeakInd <-
            which(Peaks[ , 'sample'] == Peaks[n, 'sample'] & rmInd == TRUE)
        samPeakInd <- setdiff(samPeakInd, n)
        samPeaks <- cbind(Peaks[samPeakInd, , drop=FALSE])

        for (m in seq_len(dim(samPeaks)[1])){
            if (abs(Peaks[n, 'mz'] - samPeaks[m, 'mz']) / Peaks[n, 'mz'] >= ppm)
                next
            if (abs(Peaks[n, 'rt'] - samPeaks[m, 'rt']) >= 3)
                next

            if (Peaks[n, 'maxo'] < samPeaks[m, 'maxo']){
                rmInd[n] <- FALSE
                break
            } else{
                rmInd[samPeakInd[m]] <- FALSE
            }
        }
    }
    return(Peaks[rmInd, , drop = FALSE])
}

label2path <- function(cut, gtwInfo){
    #label2path4Aosokin Convert label of src and sink to path in primal graph
    # For the graph representation of Aosokin's codes
    # Src and sink edges do not use explicit node names, but other edges do

    # cs = find(labels==0);
    ct <- which(cut == 1)

    nEdgeGrid <- gtwInfo$nEdgeGrid
    nNodeGrid <- gtwInfo$nNodeGrid
    nPix <- gtwInfo$nPix
    pEdgeSS <- gtwInfo$pEdgeSS
    pEdgeEE <- gtwInfo$pEdgeEE
    dEdgeIntSS <- gtwInfo$dEdgeIntSS
    ssTmpPos <- gtwInfo$ssTmpPos
    ss <- gtwInfo$ss
    ee <- gtwInfo$ee

    # cut for within grid
    # not suitable do this pixel by pixel due to the spatial edge
    dtmp <- matrix(0, dim(ee)[1], 2)
    ia <- matrix(is.element(ee[ ,c(1,2)], ct), dim(ee)[1], 2)
    dtmp[ia] <- 1
    isCutEE <- dtmp[ ,1] != dtmp[ , 2]

    # cut to mapping pattern in primal graph
    resPath <- vector('list', nPix)
    for (nn in seq_len(nPix)){
        # cuts within grid
        idx1 <- nEdgeGrid * (nn - 1) + 1
        idx2 <- nEdgeGrid * nn
        cutNow <- isCutEE[idx1:idx2]
        resEE <- pEdgeEE[cutNow, ]

        # src and sink cuts
        idx1 <- nNodeGrid * (nn - 1) + 1
        idx2 <- nNodeGrid * nn
        s0 <- ss[idx1:idx2, ]
        b0 <- cut[idx1:idx2]

        # idxSrcCut = find(s0(:,1)>0 & b0==1);  % nodes that cuts
        idxSrcCut <- which(ssTmpPos[ , 1] != (nPix * nPix + 1) & b0 == TRUE)
        ia <- is.element(dEdgeIntSS[ , 2], idxSrcCut)
        # get corresponding edges, src -> node
        resSrc <- pEdgeSS[ia, ]  # the primal edges

        # idxSinkCut = find(s0(:,2)>0 & b0==0);
        idxSinkCut <- which(ssTmpPos[ , 2] != nPix * nPix + 1 & b0 == 0)
        ia <- is.element(dEdgeIntSS[ , 1], idxSinkCut)  # node -> sink
        resSink <- pEdgeSS[ia, ]

        tempPath <- rbind(resEE, resSrc, resSink)
        sorted <- sort.int(tempPath[ , 1], index.return = TRUE)

        resPath[[nn]] <- tempPath[sorted$ix, ]
    }
    return(resPath)
}

warpCurve <- function(curve, path){

    nTps <- length(curve)
    warped <- matrix(0, 1, nTps)
    p0 <- path[ , c(1,2)]
    idxValid <- (p0[ , 1] >= 1) & (p0[ , 1] <= nTps) & (p0[ , 2] >= 1) &
        (p0[ , 2] <= nTps)
    p0 <- p0[idxValid, ]

    for (tt in seq_len(dim(p0)[1])){
        pRef <- p0[tt, 2]
        pTst <- p0[tt, 1]
        warped[pTst] <- max(warped[pTst], curve[pRef])
    }
    return(warped)
}


pathCombine <- function(parPath, path2, parInd){
    dataNum <- max(parInd)
    temp2path <- vector('list', dataNum)

    for (tempInd in seq_len(dataNum)){
        ind <- which(parInd == tempInd, TRUE)
        tempPath1 <- parPath[[ind[2]]][[ind[1]]]
        tempPath2 <- path2[[ind[2]]]
        newPath <- c(0,0)

        for (pixInd in 2:dim(tempPath1)[1]){
            tempPix <- tempPath1[pixInd, 1]
            tempPix2 <- tempPath2[which(tempPath2[ , 2] == tempPix)]

            tempM <- matrix(0, length(tempPix2), 2)
            tempM[ , 1] <- tempPix2
            tempM[ , 2] <- tempPath1[pixInd, 2]
            newPath <- rbind(newPath, tempM)
        }

        for (pixInd in seq(dim(newPath)[1], 2, -1)){
            if ((newPath[pixInd - 1, 1] > newPath[pixInd, 1]) ||
                (newPath[pixInd - 1, 2] > newPath[pixInd, 2])){
                newPath[pixInd, ] <- 0
            }
        }

        newPath <- cbind(newPath, rbind(newPath[2:dim(newPath)[1], ],
                                        tempPath2[dim(tempPath2)[1], 3:4]))
        temp2path[[tempInd]] <- newPath
    }
    return(temp2path)
}

#' ncGTW: A package for detecting and aligning the misaligned features in
#' LC-MS data
#'
#' The purpose of ncGTW is to help XCMS for LC-MS data alignment. Currently,
#' ncGTW can detect the misaligned feature groups by XCMS, and the user can
#' choose to realign these feature groups by ncGTW or not.
#'
#' @references Wu, Chiung-Ting, et al. Alignment of LC-MS Profiles by
#' Neighbor-wise Compound-specific Graphical Time Warping with Misalignment
#' Detection. bioRxiv, 2019, 715334.
#'
#' @docType package
#' @name ncGTW-package
#' @aliases ncGTW
#'
#' @import xcms
#' @import BiocParallel
#' @import methods
#' @importFrom grDevices dev.off png rgb
#' @importFrom graphics matplot title
#' @importFrom stats approx convolve cor kmeans median p.adjust pnorm sd t.test
#'   var weighted.mean
NULL

setGeneric("groupInfo", function(object, ...) standardGeneric("groupInfo"))
setGeneric("profiles", function(object, ...) standardGeneric("profiles"))
setGeneric("rtRaw", function(object, ...) standardGeneric("rtRaw"))

setGeneric("alignData", function(object, ...) standardGeneric("alignData"))
setGeneric("scanRange", function(object, ...) standardGeneric("scanRange"))
setGeneric("ncGTWpath", function(object, ...) standardGeneric("ncGTWpath"))
setGeneric("downSample", function(object, ...) standardGeneric("downSample"))

setGeneric("rtncGTW", function(object, ...) standardGeneric("rtncGTW"))
setGeneric("ncGTWpeaks", function(object, ...) standardGeneric("ncGTWpeaks"))

#' ncGTWinput-accessors
#'
#' Accessors to the feature and profiles loaded by \code{\link{loadProfile}}.
#' @param object a \code{\link{ncGTWinput}} object.
#' @return \code{groupInfo} returns a vector of the information of the loaded
#' feature.
#' @export
#' @rdname ncGTWinput-accessors
#' @aliases groupInfo
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#' xcmsSmallWin <- xcmsExamples$xcmsSmallWin
#' ppm <- xcmsExamples$ppm
#'
#' # detect misaligned features
#' excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
#'
#' # obtain the paths of the sample files
#' filepath <- system.file("extdata", package = "ncGTW")
#' file <- list.files(filepath, pattern="mzxml", full.names=TRUE)
#'
#' tempInd <- matrix(0, length(file), 1)
#' for (n in seq_along(file)){
#'     tempCha <- file[n]
#'     tempLen <- nchar(tempCha)
#'     tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
#'         tempLen - 6))
#' }
#' # sort the paths by data acquisition order
#' file <- file[sort.int(tempInd, index.return = TRUE)$ix]
#' \dontrun{
#' # load the sample profiles
#' ncGTWinputs <- loadProfile(file, excluGroups)
#'
#' gInfo <- groupInfo(ncGTWinputs[[1]])
#' prof <- profiles(ncGTWinputs[[1]])
#' rtR <- rtRaw(ncGTWinputs[[1]])
#' }

setMethod("groupInfo", "ncGTWinput", function(object) object@groupInfo)


#' @return \code{profiles} returns a raw data matrix in which each row is a
#' sample profile.
#' @export
#' @rdname ncGTWinput-accessors
#' @aliases profiles

setMethod("profiles", "ncGTWinput", function(object) object@profiles)


#' @return \code{rtRaw} returns a raw RT matrix in which each row is the
#' corresponding sample RT.
#' @export
#' @rdname ncGTWinput-accessors
#' @aliases rtRaw

setMethod("rtRaw", "ncGTWinput", function(object) object@rtRaw)



#' ncGTWoutput-accessors
#'
#' Accessors to the alignment information and result by ncGTW.
#' @param object a \code{\link{ncGTWoutput}} object.
#' @return \code{alignData} returns a matrix in which each row is a sample
#' profile after downsampling.
#' @export
#' @rdname ncGTWoutput-accessors
#' @aliases alignData
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#' xcmsSmallWin <- xcmsExamples$xcmsSmallWin
#' ppm <- xcmsExamples$ppm
#'
#' # detect misaligned features
#' excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
#'
#' # obtain the paths of the sample files
#' filepath <- system.file("extdata", package = "ncGTW")
#' file <- list.files(filepath, pattern="mzxml", full.names=TRUE)
#'
#' tempInd <- matrix(0, length(file), 1)
#' for (n in seq_along(file)){
#'     tempCha <- file[n]
#'     tempLen <- nchar(tempCha)
#'     tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
#'         tempLen - 6))
#' }
#' # sort the paths by data acquisition order
#' file <- file[sort.int(tempInd, index.return = TRUE)$ix]
#' \dontrun{
#' # load the sample profiles
#' ncGTWinputs <- loadProfile(file, excluGroups)
#'
#' # initialize the parameters of ncGTW alignment with default
#' ncGTWparam <- initncGTWparam()
#'
#' # run ncGTW alignment
#' ncGTWoutputs <- vector('list', length(ncGTWinputs))
#' for (n in seq_along(ncGTWinputs))
#'     ncGTWoutputs[[n]] <- ncGTWalign(ncGTWinputs[[n]], xcmsLargeWin, 5,
#'         ncGTWparam = ncGTWparam)
#'
#' data <- alignData(ncGTWoutputs[[1]])
#' rt <- scanRange(ncGTWoutputs[[1]])
#' paths <- ncGTWpath(ncGTWoutputs[[1]])
#' downSam <- downSample(ncGTWoutputs[[1]])
#' }

setMethod("alignData", "ncGTWoutput", function(object) object@alignData)


#' @return \code{scanRange} returns a downsampled RT matrix in which each row is
#' the corresponding sample RT in \code{data}.
#' @export
#' @rdname ncGTWinput-accessors
#' @aliases scanRange

setMethod("scanRange", "ncGTWoutput", function(object) object@scanRange)


#' @return \code{ncGTWpath} returns a list of the same length as the sample
#' number, in which each element is a matrix of the alignment result of the
#' corresponding sample.
#' @export
#' @rdname ncGTWinput-accessors
#' @aliases ncGTWpath

setMethod("ncGTWpath", "ncGTWoutput", function(object) object@ncGTWpath)


#' @return \code{downSample} returns the factor of downsampling when perform
#' ncGTW alignment.
#' @export
#' @rdname ncGTWinput-accessors
#' @aliases downSample

setMethod("downSample", "ncGTWoutput", function(object) object@downSample)



#' ncGTWwarp-accessors
#'
#' Accessors to the realigned RT and the peaks with adjusted RT of ncGTW
#' alignment.
#' @param object a \code{\link{ncGTWwarp}} object.
#' @return \code{rtncGTW} returns a list of the same length as the sample
#' number, in which each element is a vector of the realigned RT of the
#' corresponding sample.
#' @export
#' @rdname ncGTWwarp-accessors
#' @aliases rtncGTW
#' @examples
#' # obtain data
#' data('xcmsExamples')
#' xcmsLargeWin <- xcmsExamples$xcmsLargeWin
#' xcmsSmallWin <- xcmsExamples$xcmsSmallWin
#' ppm <- xcmsExamples$ppm
#'
#' # detect misaligned features
#' excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
#'
#' # obtain the paths of the sample files
#' filepath <- system.file("extdata", package = "ncGTW")
#' file <- list.files(filepath, pattern="mzxml", full.names=TRUE)
#'
#' tempInd <- matrix(0, length(file), 1)
#' for (n in seq_along(file)){
#'     tempCha <- file[n]
#'     tempLen <- nchar(tempCha)
#'     tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
#'         tempLen - 6))
#' }
#' # sort the paths by data acquisition order
#' file <- file[sort.int(tempInd, index.return = TRUE)$ix]
#' \dontrun{
#' # load the sample profiles
#' ncGTWinputs <- loadProfile(file, excluGroups)
#'
#' # initialize the parameters of ncGTW alignment with default
#' ncGTWparam <- initncGTWparam()
#'
#' # run ncGTW alignment
#' ncGTWoutputs <- vector('list', length(ncGTWinputs))
#' ncGTWoutputs[[1]] <- ncGTWalign(ncGTWinputs[[1]], xcmsLargeWin, 5,
#'         ncGTWparam = ncGTWparam)
#'
#' # adjust RT with the realignment results from ncGTW
#' ncGTWres <- xcmsLargeWin
#' adjustRes <- adjustRT(ncGTWres, ncGTWinputs[[1]], ncGTWoutputs[[1]], ppm)
#' rt <- rtncGTW(adjustRes)
#' peaks <- ncGTWpeaks(adjustRes)
#' }

setMethod("rtncGTW", "ncGTWwarp", function(object) object@rtncGTW)


#' @return \code{rtncGTW} returns a matrix containing peak data with adjusted
#' RT.
#' @export
#' @rdname ncGTWwarp-accessors
#' @aliases ncGTWpeaks

setMethod("ncGTWpeaks", "ncGTWwarp", function(object) object@ncGTWpeaks)


setMethod("initialize", "ncGTWparam", function(.Object, ...) {
            .Object <- callNextMethod()

            if (length(.Object@downSample) == 0){
                .Object@downSample <- 2
            }
            if (.Object@downSample < 1 ) {
                stop("The value of 'downSample' must be larger or equal to 1.")
            }

            if (length(.Object@stpRat) == 0){
                .Object@stpRat <- 0.6
            }
            if (.Object@stpRat <= 0 || .Object@stpRat > 1) {
                stop("The value of 'stpRat' must be between 0 and 1.")
            }

            if (length(.Object@maxStp) == 0){
                .Object@maxStp <- NaN
            }
            if (!is.nan(.Object@maxStp)){
                if (.Object@maxStp < 1 || .Object@maxStp %% 1 != 0) {
                    stop("The value of 'maxStp' must be a natural number.")
                }
            }

            if (length(.Object@strNum) == 0){
                .Object@strNum <- 1
            }
            if (.Object@strNum < 1 || .Object@strNum %% 1 != 0) {
                stop("The value of 'strNum' must be a natural number.")
            }

            if (length(.Object@diaNum) == 0){
                .Object@diaNum <- 1
            }
            if (.Object@diaNum < 1 || .Object@diaNum %% 1 != 0) {
                stop("The value of 'diaNum' must be a natural number.")
            }

            if (length(.Object@nor) == 0){
                .Object@nor <- 1
            }
            if (.Object@nor < 0) {
                stop("The value of 'nor' must be larger or equal to 0.")
            }
            return(.Object)
    }
)

---
title: "ncGTW User Manual"
package: ncGTW
author: "Chiung-Ting Wu"
date: "`r Sys.Date()`"
bibliography: references.bib
csl: biomed-central.csl
output: 
    BiocStyle::html_document:
        toc: true
vignette: >
    %\VignetteIndexEntry{ncGTW User Manual}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
    %\VignettePackage{ncGTW}
    %\VignetteKeywords{mass spectrometry, metabolomics, alignment}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse=TRUE,
    comment="#>"
)
```

# Introduction

Neighbor-wise Compound-specific Graphical Time Warping (ncGTW) [@ncgtw19] is an 
alignment algorithm that can align LC-MS profiles by leveraging expected 
retention time (RT) drift structures and compound-specific warping functions. 
This algorithm is improved from graphical time warping (GTW) [@gtw16], a popular
dynamic time warping (DTW) based alignment method [@dtw90]. Specifically, ncGTW 
uses individualized warping functions for different compounds and assigns 
constraint edges on warping functions of neighboring samples. That is, ncGTW 
avoids the popular but not accurate assumption which assumes all the m/z bins in
the same sample share the same warping function. This assumption often fails 
when the dataset contains hundreds of samples or the data acquisition time 
longer than a week. Moreover, by considering the RT drifts structure, ncGTW can
align RT more accurately.

`ncGTW` is an R package developed as a plug-in of `xcms`, a popular LC-MS data
analysis R package [@xcms06; @xcms08; @xcms10]. Due to the same warping function
assumption or bad parameter settings, `xcms` may have some misaligned features,
and there is a function in `ncGTW` to identify such misalignments. After
identifying the misaligned features, the user can realign these features with
the alignment function in `ncGTW` to obtain a better alignment result for more
accurate analysis, such as peak-regrouping or peak-filling with `xcms`.

You can install the latest version of ncGTW from GitHub by
```{r, eval = FALSE}
devtools::install_github("ChiungTingWu/ncGTW")
```
or from Bioconductor by
```{r, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("ncGTW")
```

# Quick Start

To check there are misaligned features from `xcms` or not, one can input two
`xcms` grouping results with different values of RT window parameter (`xcms`
grouping parameter, `bw`) to the function `misalignDetect()`. One value of `bw`
should be the expected maximal RT drift, and another should be near to the RT
sampling resolution (the inverse of scan frequency). If there are some detected
misaligned features, the user can decide to adjust the paramters in `xcms` or
use `ncGTW` to realign them. Besides the `xcms` aligment results, the only
paramter with no default in `misalignDetect()` is `ppm`, which should be set as
same as `ppm` of the peak detection in `xcms`.

```{r, eval = FALSE}
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
```

# Misaligned Feature Detection and Realignment

## RT Structure Incorporation

To demonstrate the workflow of ncGTW, an example dataset is included in the
package. The aquisition time of the dataset is more than two weeks, in which the
20 samples are selected from a large dataset for a quick demonstration.

```{r, message = FALSE}
library(xcms)
library(ncGTW)
filepath <- system.file("extdata", package = "ncGTW")
file <- list.files(filepath, pattern = "mzxml", full.names = TRUE)
# The paths of the 20 samples
```

To incorporate the RT structure, the order of the paths in `file` should be as
same as the sample acquisition order (run order). In the example dataset, the
index in each file name is the acquisition order, so we sort the paths according
to `tempInd`. When dealing with other dataset, the user should make sure the
order of the paths is as same the order of data acquisition.

```{r}
tempInd <- matrix(0, length(file), 1)
for (n in seq_along(file)){
    tempCha <- file[n]
    tempLen <- nchar(tempCha)
    tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7, 
        tempLen - 6))
}
file <- file[sort.int(tempInd, index.return = TRUE)$ix]
# Sort the paths by data acquisition order to incorporate the RT structure
```

## XCMS Preprocessing

As a plug-in, the inputs of `ncGTW` are the alignment results from `xcms`, so
first we need to apply `xcms` on the dataset. The parameters should be decided
by the user when dealing with other datasets.

```{r, message = FALSE, warning = FALSE}
CPWmin <- 2 
CPWmax <- 25 
ppm <- 15 
xsnthresh <- 3 
LM <- FALSE
integrate <- 2 
RTerror <- 6 
MZerror <- 0.05
prefilter <- c(8, 1000)
# XCMS parameters
ds <- xcmsSet(file, method="centWave", peakwidth=c(CPWmin, CPWmax), ppm=ppm, 
    noise=xsnthresh, integrate=integrate, prefilter=prefilter)
gds <- group(ds, mzwid=MZerror, bw=RTerror)
agds <- retcor(gds, missing=5)
# XCMS peak detection and RT alignment
```

To detect the misaligned features, `ncGTW` needs two XCMS grouping results with
different values of `bw`. The larger one should be expected maximal RT drift,
and the smaller one should be the RT sampling resolution (the inverse of scan
frequency).

```{r, message = FALSE}
bwLarge <- RTerror
bwSmall <- 0.3
# Two different values of bw parameter
xcmsLargeWin <- group(agds, mzwid=MZerror, bw=bwLarge)
xcmsSmallWin <- group(agds, mzwid=MZerror, bw=bwSmall, minfrac=0)
# Two resolution of XCMS grouping results
```

## ncGTW Workflow

After XCMS preprocessing, `ncGTW` can be applied on the results. There are two
major steps in `ncGTW`, misaligned feature detection and misaligned feature
realignment.


### Misaligned Feature Detection

To detect the misaligned features, `misalignDetect()` needs two different XCMS
grouping results as inputs. This function tells which features in `xcmsLargeWin`
could be broken into several small features in `xcmsSmallWin`, and the detected
features should be misaligned features. `ppm` is one criteria to decide the
small features in `xcmsLargeWin` are from the same compounds or not, and should
be set as same as the one in XCMS peak detection.

```{r, message = FALSE}
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
# Detect misaligned features
show(excluGroups)
```

There are two peak groups (features) are detected as shown in `excluGroups`. 
Before realigning them, the raw profile of each detected feature of each sample 
needs to load from the files. `loadProfile()` loads the needed information with 
file paths (`file`) and the detected features (`excluGroups`) as inputs.

```{r, message = FALSE}
ncGTWinputs <- loadProfile(file, excluGroups)
# Load raw profiles from the files
```

The user can also check the detected features are really misaligned or not by
viewing the extracted ion chromatogram. `plotGroup()` draws the extracted ion
chromatogram. `ncGTWinputs` is the loaded information from `loadProfile()`,
`xcmsLargeWin@rt$corrected` is the alignment by XCMS, and `ind` is just a
parameter for indexing the chromatograms. The user are free to set `ind`.

```{r, message = FALSE}
for (n in seq_along(ncGTWinputs))
    plotGroup(ncGTWinputs[[n]], slot(xcmsLargeWin, 'rt')$corrected, ind=n)
    # (Optional) Draw the detected misaligned features
```

From the two figures, it is clear that these two features are really misaligned.
The color of curves changes from green, purple, to red according to the sample
run order.

### Misaligned Feature Realignment

After the needed information is loaded to `ncGTWinputs`, we can start to realign
the detected features with `ncGTW`. The parameter `parSamp` is for parallel
computing, which decides how many samples would be aligned together each time.
In this example, there are 20 samples, and `parSamp` are set as 5. Thus, there
would be four sub-groups of samples, and there are five samples in each
sub-group. Also, `bpParam` is set as four workers to align the four sub-groups
simultaneously. After all sub-groups are aligned, `ncGTW` would integrate the
four alignment results together to generate the final realignment.
If the user do not need parallel computing, `parSamp` could be set as same as
the total sample number. However, if sample number is larger than 100, it is
strongly recommended to split the samples into several sub-groups.

```{r, message = FALSE}
ncGTWoutputs <- vector('list', length(ncGTWinputs))
# Prepare the output variable
ncGTWparam <- new("ncGTWparam")
# Initialize the parameters of ncGTW alignment with default
for (n in seq_along(ncGTWinputs))
    ncGTWoutputs[[n]] <- ncGTWalign(ncGTWinputs[[n]], xcmsLargeWin, parSamp=5,
        bpParam=SnowParam(workers=4), ncGTWparam=ncGTWparam)
# Perform ncGTW alignment
```

After realignment, we need to send the realignment result to `adjustRT()` to
generate new RT warping functions to replace `xcmsLargeWin@rt$corrected`, and
send them back to `xcms` for further analysis.

```{r, message = FALSE}
ncGTWres <- xcmsLargeWin
# Prepare a new xcmsSet to contain the realignment result
ncGTWRt <- vector('list', length(ncGTWinputs))
for (n in seq_along(ncGTWinputs)){
    adjustRes <- adjustRT(ncGTWres, ncGTWinputs[[n]], ncGTWoutputs[[n]], ppm)
    # Generate the new warping functions
    peaks(ncGTWres) <- ncGTWpeaks(adjustRes)
    # Relocate the peaks to the new RT points according to the realignment.  
    ncGTWRt[[n]] <- rtncGTW(adjustRes)
    # Temporary variable for new warping functions 
}
```

Again, the user can also check the realignment by viewing the extracted ion
chromatogram with `plotGroup()`.

```{r, message = FALSE}
for (n in seq_along(ncGTWinputs))
    plotGroup(ncGTWinputs[[n]], ncGTWRt[[n]], ind = n)
    # (Optional) Draw the realigned features
```

From the two figures, it is clear that the two misaligned features now are
realigned accurately, comparing to the XCMS alignment.

## Peak-filling with Realigned RT

One of the most obvious impact of the realignment is the quality of peak-filling
in `xcms`. Due to the more accurate warping functions, the peak-filling step has
a higher change to retrieve the missing peaks back. That is, the guessing of the
positions of the missing peaks becomes more accurate according to the new
warping functions. Here we demonstrate the differences of peak-filling of the
two misaligned features.

```{r, message = FALSE}
groups(ncGTWres) <- excluGroups[ , 2:9]
groupidx(ncGTWres) <- groupidx(xcmsLargeWin)[excluGroups[ , 1]]
# Only consider the misaligned features
rtCor <- vector('list', length(file))
for (n in seq_along(file)){
    rtCor[[n]] <- vector('list', dim(excluGroups)[1])
    for (m in seq_len(dim(groups(ncGTWres))[1]))
        rtCor[[n]][[m]] <- ncGTWRt[[m]][[n]]
}
slot(ncGTWres, 'rt')$corrected <- rtCor
# Replace the XCMS warping function to ncGTW warping function
XCMSres <- xcmsLargeWin
groups(XCMSres) <- excluGroups[ , 2:9]
groupidx(XCMSres) <- groupidx(xcmsLargeWin)[excluGroups[ , 1]]
# Consider only the misaligned features with XCMS warping function
```

After extracting the misaligned features and replacing the old warping 
functions, we can apply `fillPeaks` in `xcms` for peak-filling. Since  
`fillPeaks` accepts only one warping function for each sample, we need to 
replace the function `fillPeaksChromPar()` first.

```{r, message = FALSE}
assignInNamespace("fillPeaksChromPar", ncGTW:::fillPeaksChromPar, ns="xcms",
    envir=as.environment("package:xcms"))
# Replace fillPeaksChromPar() in XCMS
ncGTWresFilled <- fillPeaks(ncGTWres)
XCMSresFilled <- fillPeaks(XCMSres)
# Peak-filling with old and new warping functions
compCV(XCMSresFilled)
compCV(ncGTWresFilled)
# Compare the coefficient of variation
```

For the first misaligned feature, the coefficient of variation (CV) decreases
from 0.369 to 0.229, and for the second one, the CV decreases from 0.351 to
0.119. Thus, it is very clear that new warping functions improve the quality of
peak-filling significantly.

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misalignDetect.R
\name{misalignDetect}
\alias{misalignDetect}
\title{Detect misaligned peak groups in xcmsSet object of XCMS}
\usage{
misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm, qThre = 0.05,
  overlapRate = 0, maxRtWin = 50)
}
\arguments{
\item{xcmsLargeWin}{A \code{\link[xcms]{xcmsSet-class}} object with a larger
\code{bw}, usually the maximum expected retension time drift.}

\item{xcmsSmallWin}{A \code{\link[xcms]{xcmsSet-class}} object with a smaller
\code{bw}, usually the resolution of the retension time.}

\item{ppm}{Should be set as same as the one when performing the peak
detection function in \code{xcms}.}

\item{qThre}{The threshould of the p-value after multiple test correction.
The default is 0.05.}

\item{overlapRate}{The threshould of the overlapping rate of sample index.
The default is 0.}

\item{maxRtWin}{The threshould of the maximum retension time range. This is
for filtering out some bad groups. The default is 50 (seconds).}
}
\value{
A matrix with all detected misaligned peak groups. The column names
are the same as \code{group} slot in \code{\link[xcms]{xcmsSet-class}}, but
the first column is the group index.
}
\description{
This function detects the misaligned peak groups with two
\code{\link[xcms]{xcmsSet-class}} object with two different values of
\code{bw} parameter in \code{\link[xcms:group.density]{group}}.
}
\details{
This function includes two major steps to determine a peak group is
misaligned or not. The first step calculates the p-value of each peak group
in xcmsSmallWin, and find the corresponding peak group in xcmsLargeWin. The
second step is to find the exclusive peak groups (the groups with no
overlapping samples) with adjsted p-values smaller than \code{qThre}.
}
\examples{
# obtain data
data('xcmsExamples')
xcmsLargeWin <- xcmsExamples$xcmsLargeWin
xcmsSmallWin <- xcmsExamples$xcmsSmallWin
ppm <- xcmsExamples$ppm

# detect misaligned features
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ncGTWutility.R
\name{compCV}
\alias{compCV}
\title{Compare CV}
\usage{
compCV(XCMSresFilled, na.rm = FALSE)
}
\arguments{
\item{XCMSresFilled}{A \code{\link[xcms]{xcmsSet-class}} object.}

\item{na.rm}{Omit the samples in which the feature is not detected, and the
default is FALSE.}
}
\value{
A vector of the same length as the row number of the \code{group}
slot in \code{XCMSresFilled}, in which each element is the CV.
}
\description{
This function calculates the coefficient of variation of each feature.
}
\details{
This function calculates the coefficient of variation of each
feature across all the samples. If a sample is detected with more than one
peaks in the feature, the function will pick the one with the highest
intensity value.
}
\examples{
# obtain data
data('xcmsExamples')
xcmsLargeWin <- xcmsExamples$xcmsLargeWin

cv <- compCV(xcmsLargeWin)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allClasses.R
\docType{class}
\name{ncGTWoutput-class}
\alias{ncGTWoutput-class}
\alias{ncGTWoutput}
\title{Class "ncGTWoutput"}
\description{
An S4 class for storing the outputs of ncGTW alignment.
}
\section{Slots}{

\describe{
\item{\code{alignData}}{A matrix in which each row is a sample profile after
downsampling.}

\item{\code{scanRange}}{A downsampled RT matrix in which each row is the
corresponding sample RT in \code{alignData}.}

\item{\code{path}}{A list of the same length as the sample number, in which
each element is a matrix of the alignment result of the corresponding
sample.}

\item{\code{downSample}}{The factor of downsampling when perform ncGTW
alignment.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allMethods.R
\docType{methods}
\name{groupInfo,ncGTWinput-method}
\alias{groupInfo,ncGTWinput-method}
\alias{groupInfo}
\alias{profiles,ncGTWinput-method}
\alias{profiles}
\alias{rtRaw,ncGTWinput-method}
\alias{rtRaw}
\alias{scanRange,ncGTWoutput-method}
\alias{scanRange}
\alias{ncGTWpath,ncGTWoutput-method}
\alias{ncGTWpath}
\alias{downSample,ncGTWoutput-method}
\alias{downSample}
\title{ncGTWinput-accessors}
\usage{
\S4method{groupInfo}{ncGTWinput}(object)

\S4method{profiles}{ncGTWinput}(object)

\S4method{rtRaw}{ncGTWinput}(object)

\S4method{scanRange}{ncGTWoutput}(object)

\S4method{ncGTWpath}{ncGTWoutput}(object)

\S4method{downSample}{ncGTWoutput}(object)
}
\arguments{
\item{object}{a \code{\link{ncGTWinput}} object.}
}
\value{
\code{groupInfo} returns a vector of the information of the loaded
feature.

\code{profiles} returns a raw data matrix in which each row is a
sample profile.

\code{rtRaw} returns a raw RT matrix in which each row is the
corresponding sample RT.

\code{scanRange} returns a downsampled RT matrix in which each row is
the corresponding sample RT in \code{data}.

\code{ncGTWpath} returns a list of the same length as the sample
number, in which each element is a matrix of the alignment result of the
corresponding sample.

\code{downSample} returns the factor of downsampling when perform
ncGTW alignment.
}
\description{
Accessors to the feature and profiles loaded by \code{\link{loadProfile}}.
}
\examples{
# obtain data
data('xcmsExamples')
xcmsLargeWin <- xcmsExamples$xcmsLargeWin
xcmsSmallWin <- xcmsExamples$xcmsSmallWin
ppm <- xcmsExamples$ppm

# detect misaligned features
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)

# obtain the paths of the sample files
filepath <- system.file("extdata", package = "ncGTW")
file <- list.files(filepath, pattern="mzxml", full.names=TRUE)

tempInd <- matrix(0, length(file), 1)
for (n in seq_along(file)){
    tempCha <- file[n]
    tempLen <- nchar(tempCha)
    tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
        tempLen - 6))
}
# sort the paths by data acquisition order
file <- file[sort.int(tempInd, index.return = TRUE)$ix]
\dontrun{
# load the sample profiles
ncGTWinputs <- loadProfile(file, excluGroups)

gInfo <- groupInfo(ncGTWinputs[[1]])
prof <- profiles(ncGTWinputs[[1]])
rtR <- rtRaw(ncGTWinputs[[1]])
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ncGTWutility.R
\name{meanCorOl}
\alias{meanCorOl}
\title{Compute average pairwise correlation and overlapping area}
\usage{
meanCorOl(ncGTWinput, sampleRt)
}
\arguments{
\item{ncGTWinput}{A list in which each element is a \code{\link{ncGTWinput}}
object.}

\item{sampleRt}{A list of the same length as the sample number in which each
element is a vector corresponding to the sample raw/adjusted RT.}
}
\value{
A list in which the first element is average pairwise correlation,
and the second one is average overlapping area.
}
\description{
This function computes average pairwise correlation and overlapping area of
each sample pair.
}
\details{
This function computes the pairwise correlation and overlapping area
of each sample pair from the input feature, and then takes average.
}
\examples{
# obtain data
data('xcmsExamples')
xcmsLargeWin <- xcmsExamples$xcmsLargeWin
xcmsSmallWin <- xcmsExamples$xcmsSmallWin
ppm <- xcmsExamples$ppm

# detect misaligned features
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)

# obtain the paths of the sample files
filepath <- system.file("extdata", package = "ncGTW")
file <- list.files(filepath, pattern="mzxml", full.names=TRUE)

tempInd <- matrix(0, length(file), 1)
for (n in seq_along(file)){
    tempCha <- file[n]
    tempLen <- nchar(tempCha)
    tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
        tempLen - 6))
}
# sort the paths by data acquisition order
file <- file[sort.int(tempInd, index.return = TRUE)$ix]

# load the sample profiles
ncGTWinputs <- loadProfile(file, excluGroups)

XCMSCor <- matrix(0, length(ncGTWinputs), 1)
XCMSOl <- matrix(0, length(ncGTWinputs), 1)
for (n in seq_along(ncGTWinputs)){
    XCMSmean <- meanCorOl(ncGTWinputs[[n]],
        slot(xcmsLargeWin, 'rt')$corrected)
    XCMSCor[n] <- XCMSmean$cor
    XCMSOl[n] <- XCMSmean$ol
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/XCMSedited.R
\name{fillPeaksChromPar}
\alias{fillPeaksChromPar}
\title{Edited XCMS fillPeaksChromPar for feature-wise warping functions}
\usage{
fillPeaksChromPar(arg)
}
\arguments{
\item{arg}{A list sent from \code{\link[xcms]{fillPeaks.chrom-methods}}.}
}
\value{
A list of sameple index vector and filled peak matrix.
}
\description{
This function is edited from \code{fillPeaksChromPar} in
\code{\link[xcms]{fillPeaks.chrom-methods}} to accept feature-wise warping
functions.
}
\details{
This function is for parallelly filling missing peaks with
feature-wise warping functions. The original function in
\code{\link[xcms]{fillPeaks.chrom-methods}} can only handle sample-wise
warping functions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allMethods.R
\docType{methods}
\name{alignData,ncGTWoutput-method}
\alias{alignData,ncGTWoutput-method}
\alias{alignData}
\title{ncGTWoutput-accessors}
\usage{
\S4method{alignData}{ncGTWoutput}(object)
}
\arguments{
\item{object}{a \code{\link{ncGTWoutput}} object.}
}
\value{
\code{alignData} returns a matrix in which each row is a sample
profile after downsampling.
}
\description{
Accessors to the alignment information and result by ncGTW.
}
\examples{
# obtain data
data('xcmsExamples')
xcmsLargeWin <- xcmsExamples$xcmsLargeWin
xcmsSmallWin <- xcmsExamples$xcmsSmallWin
ppm <- xcmsExamples$ppm

# detect misaligned features
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)

# obtain the paths of the sample files
filepath <- system.file("extdata", package = "ncGTW")
file <- list.files(filepath, pattern="mzxml", full.names=TRUE)

tempInd <- matrix(0, length(file), 1)
for (n in seq_along(file)){
    tempCha <- file[n]
    tempLen <- nchar(tempCha)
    tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
        tempLen - 6))
}
# sort the paths by data acquisition order
file <- file[sort.int(tempInd, index.return = TRUE)$ix]
\dontrun{
# load the sample profiles
ncGTWinputs <- loadProfile(file, excluGroups)

# initialize the parameters of ncGTW alignment with default
ncGTWparam <- initncGTWparam()

# run ncGTW alignment
ncGTWoutputs <- vector('list', length(ncGTWinputs))
for (n in seq_along(ncGTWinputs))
    ncGTWoutputs[[n]] <- ncGTWalign(ncGTWinputs[[n]], xcmsLargeWin, 5,
        ncGTWparam = ncGTWparam)

data <- alignData(ncGTWoutputs[[1]])
rt <- scanRange(ncGTWoutputs[[1]])
paths <- ncGTWpath(ncGTWoutputs[[1]])
downSam <- downSample(ncGTWoutputs[[1]])
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/XCMSedited.R
\name{getPeaksncGTW}
\alias{getPeaksncGTW}
\title{Edited XCMS getPeaks for feature-wise warping functions}
\usage{
getPeaksncGTW(object, peakrange, step = 0.1, naidx)
}
\arguments{
\item{object}{An \code{\link[xcms]{xcmsRaw-class}} object.}

\item{peakrange}{\code{matrix} with 4 required columns \code{"mzmin"},
\code{"mzmax"}, \code{"rtmin"} and \code{"rtmax"}.}

\item{step}{\code{numeric(1)} defining the bin size for the profile matrix
generation.}

\item{naidx}{A vector contains the sample indexes need to be filled.}
}
\value{
A list of sameple index vector and filled peak matrix.
}
\description{
This function is edited from \code{\link[xcms]{getPeaks-methods}} to accept
feature-wise warping functions.
}
\details{
This function is for parallelly filling missing peaks with
feature-wise warping functions. The original code function in
\code{\link[xcms]{getPeaks-methods}} can only handle sample-wise warping
functions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ncGTWalign.R
\name{ncGTWalign}
\alias{ncGTWalign}
\title{Run ncGTW alignment}
\usage{
ncGTWalign(ncGTWinput, xcmsLargeWin, parSamp = 10, k1Num = 3,
  k2Num = 1, bpParam = BiocParallel::SnowParam(workers = 1),
  ncGTWparam = NULL)
}
\arguments{
\item{ncGTWinput}{A \code{\link{ncGTWinput}} object.}

\item{xcmsLargeWin}{A \code{\link[xcms]{xcmsSet-class}} object.}

\item{parSamp}{Decide how many samples are in each group when considering
parallel computing, and the default is 10.}

\item{k1Num}{Decide how many different k1 will be tested in stage 1. The
default is 3.}

\item{k2Num}{Decide how many different k2 will be tested in stage 2. The
default is 1.}

\item{bpParam}{A object of \pkg{BiocParallel} to control parallel processing,
and can be created by
\code{\link[BiocParallel:SerialParam-class]{SerialParam}},
\code{\link[BiocParallel:MulticoreParam-class]{MulticoreParam}}, or
\code{\link[BiocParallel:SnowParam-class]{SnowParam}}.}

\item{ncGTWparam}{A \code{\link{ncGTWparam}} object.}
}
\value{
A \code{\link{ncGTWoutput}} object.
}
\description{
This function applies ncGTW alignment to the input feature.
}
\details{
This function realign the input feature with ncGTW alignment
function with given m/z and RT range.
}
\examples{
# obtain data
data('xcmsExamples')
xcmsLargeWin <- xcmsExamples$xcmsLargeWin
xcmsSmallWin <- xcmsExamples$xcmsSmallWin
ppm <- xcmsExamples$ppm

# detect misaligned features
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)

# obtain the paths of the sample files
filepath <- system.file("extdata", package = "ncGTW")
file <- list.files(filepath, pattern="mzxml", full.names=TRUE)

tempInd <- matrix(0, length(file), 1)
for (n in seq_along(file)){
    tempCha <- file[n]
    tempLen <- nchar(tempCha)
    tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
        tempLen - 6))
}
# sort the paths by data acquisition order
file <- file[sort.int(tempInd, index.return = TRUE)$ix]
\dontrun{
# load the sample profiles
ncGTWinputs <- loadProfile(file, excluGroups)

# initialize the parameters of ncGTW alignment with default
ncGTWparam <- new("ncGTWparam")

# run ncGTW alignment
ncGTWoutputs <- vector('list', length(ncGTWinputs))
for (n in seq_along(ncGTWinputs))
    ncGTWoutputs[[n]] <- ncGTWalign(ncGTWinputs[[n]], xcmsLargeWin, 5,
        ncGTWparam = ncGTWparam)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/xcmsExamples.R
\docType{data}
\name{xcmsExamples}
\alias{xcmsExamples}
\title{Examples of xcmsSet for inputs of ncGTW}
\format{A list with two \code{\link[xcms]{xcmsSet-class}} objects and one
  \code{ppm} parameter.}
\usage{
data(xcmsExamples)
}
\description{
These two \code{\link[xcms]{xcmsSet-class}} objects are created from the
example dataset attached in this package (in extdata folder) with XCMS
package. They are examples for inputs of \code{\link{misalignDetect}}.
}
\details{
The example dataset contains 20 samples picked from an in-house LC-MS
dataset. The user can replicate the two \code{\link[xcms]{xcmsSet-class}}
objects with \code{\link[xcms]{xcmsSet}}, \code{\link[xcms]{retcor-methods}},
and \code{\link[xcms]{group-methods}}. For details, please refer to the user
manual.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allClasses.R
\docType{class}
\name{ncGTWinput-class}
\alias{ncGTWinput-class}
\alias{ncGTWinput}
\title{Class "ncGTWinput"}
\description{
An S4 class for storing the inputs of ncGTW alignment.
}
\section{Slots}{

\describe{
\item{\code{groupInfo}}{A vector of the information of the feature.}

\item{\code{profiles}}{A raw data matrix in which each row is a sample profile.}

\item{\code{rtRaw}}{A raw RT matrix in which each row is the corresponding
sample RT in \code{profiles}.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allClasses.R
\docType{class}
\name{ncGTWparam-class}
\alias{ncGTWparam-class}
\alias{ncGTWparam}
\title{Class "ncGTWparam"}
\description{
An S4 class for storing the needed paramters of ncGTW alignment.
}
\details{
This function initializes the needed paramters of ncGTW alignment
with defaults, so this function could be called without any input. The
alignment should be fine with all default parameters. If the computing time
is an issue, the user could consider increase \code{downSample} and/or
decrease \code{stpRat} for a faster speed. If the alignment result is not
good enough, one can consider increase \code{strNum} and/or \code{diaNum}
to integrate more neighboring information to increase the quality of
alignment, but the speed may drop.
}
\section{Slots}{

\describe{
\item{\code{downSample}}{A factor of downsampling. The larger, the faster speed
of alignment, but the accuracy may decrease. The default is 2.}

\item{\code{stpRat}}{A factor to control the maximum RT shift of a point in
alignment, and the maximum shift is determined by \code{stpRat} * "The RT
range of the feature". If \code{maxStp} is set, then \code{stpRat} would be
neglected. The default is 0.6.}

\item{\code{maxStp}}{A value determines the maximum RT shift of a point in ncGTW
alignment. If the user wants to decide the maximum shif by the RT range of
the feature, this argument should be NaN. The default is NaN.}

\item{\code{strNum}}{A value controls how many neighboring warping functions are
connected to each warping function in ncGTW graph. There are two samples
corresponding to a warping function, and at least one sample should be the
same in another warping function to be considered as a neighbor controlled
by \code{strNum}.}

\item{\code{diaNum}}{A value controls how many neighboring warping functions are
connected to each warping function in ncGTW graph. There are two samples
corresponding to a warping function, and the two samples could also be
different to another warping function to be considered as a neighbor
controlled by \code{diaNum}.}

\item{\code{nor}}{A value controls p-norm to compute the distance between the
points on the profiles, and the default is 1 (Manhattan norm).}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ncGTWwarp.R
\name{adjustRT}
\alias{adjustRT}
\title{Adjust retention time}
\usage{
adjustRT(xcmsLargeWin, ncGTWinput, ncGTWoutput, ppm)
}
\arguments{
\item{xcmsLargeWin}{A \code{\link[xcms]{xcmsSet-class}} object.}

\item{ncGTWinput}{A \code{\link{ncGTWinput}} object.}

\item{ncGTWoutput}{A \code{\link{ncGTWoutput}} object.}

\item{ppm}{Should be set as same as the one when performing the peak
detection function in \code{xcms}.}
}
\value{
A \code{\link{ncGTWwarp}} object.
}
\description{
This function produces the new warping functions (RT lists) with the
realignment result.
}
\details{
This function produces the new warping functions (RT lists) with the
realignment result.
}
\examples{
# obtain data
data('xcmsExamples')
xcmsLargeWin <- xcmsExamples$xcmsLargeWin
xcmsSmallWin <- xcmsExamples$xcmsSmallWin
ppm <- xcmsExamples$ppm

# detect misaligned features
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)

# obtain the paths of the sample files
filepath <- system.file("extdata", package = "ncGTW")
file <- list.files(filepath, pattern="mzxml", full.names=TRUE)

tempInd <- matrix(0, length(file), 1)
for (n in seq_along(file)){
    tempCha <- file[n]
    tempLen <- nchar(tempCha)
    tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
        tempLen - 6))
}
# sort the paths by data acquisition order
file <- file[sort.int(tempInd, index.return = TRUE)$ix]
\dontrun{
# load the sample profiles
ncGTWinputs <- loadProfile(file, excluGroups)

# initialize the parameters of ncGTW alignment with default
ncGTWparam <- new("ncGTWparam")

# run ncGTW alignment
ncGTWoutputs <- vector('list', length(ncGTWinputs))
for (n in seq_along(ncGTWinputs))
    ncGTWoutputs[[n]] <- ncGTWalign(ncGTWinputs[[n]], xcmsLargeWin, 5,
        ncGTWparam = ncGTWparam)

# adjust RT with the realignment results from ncGTW
ncGTWres <- xcmsLargeWin
ncGTWRt <- vector('list', length(ncGTWinputs))
for (n in seq_along(ncGTWinputs)){
    adjustRes <- adjustRT(ncGTWres, ncGTWinputs[[n]], ncGTWoutputs[[n]], ppm)
    xcms::peaks(ncGTWres) <- ncGTWpeaks(adjustRes)
    ncGTWRt[[n]] <- rtncGTW(adjustRes)
}

# apply the adjusted RT to a xcmsSet object
xcms::groups(ncGTWres) <- excluGroups[ , 2:9]
xcms::groupidx(ncGTWres) <- xcms::groupidx(xcmsLargeWin)[excluGroups[ , 1]]
rtCor <- vector('list', length(xcms::filepaths(ncGTWres)))
for (n in seq_along(file)){
    rtCor[[n]] <- vector('list', dim(excluGroups)[1])
    for (m in seq_len(dim(excluGroups)[1]))
        rtCor[[n]][[m]] <- ncGTWRt[[m]][[n]]
}
slot(ncGTWres, 'rt')$corrected <- rtCor
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ncGTW.R
\docType{package}
\name{ncGTW-package}
\alias{ncGTW-package}
\alias{ncGTW}
\title{ncGTW: A package for detecting and aligning the misaligned features in
LC-MS data}
\description{
The purpose of ncGTW is to help XCMS for LC-MS data alignment. Currently,
ncGTW can detect the misaligned feature groups by XCMS, and the user can
choose to realign these feature groups by ncGTW or not.
}
\references{
Wu, Chiung-Ting, et al. Alignment of LC-MS Profiles by
Neighbor-wise Compound-specific Graphical Time Warping with Misalignment
Detection. bioRxiv, 2019, 715334.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allClasses.R
\docType{class}
\name{ncGTWwarp-class}
\alias{ncGTWwarp-class}
\alias{ncGTWwarp}
\title{Class "ncGTWwarp"}
\description{
An S4 class for storing the realigned RT and the peaks with adjusted RT of
ncGTW alignment.
}
\section{Slots}{

\describe{
\item{\code{rtncGTW}}{A list of the same length as the sample number, in which
each element is a vector of the realigned RT of the corresponding sample.}

\item{\code{ncGTWpeaks}}{A matrix containing peak data with adjusted RT.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/loadProfile.R
\name{loadProfile}
\alias{loadProfile}
\title{Load sample profiles for each peak group}
\usage{
loadProfile(filePaths, excluGroups, mzAdd = 0.005, rtAdd = 10,
  profstep = 0, BPPARAM = BiocParallel::SnowParam(workers = 1))
}
\arguments{
\item{filePaths}{The character vector of the loading file paths.}

\item{excluGroups}{The output matrix of \code{\link{misalignDetect}} or
\code{\link[xcms]{xcmsSet-class}}$\code{group}, in which \code{mzmin},
\code{mzmax}, \code{rtmin}, and \code{rtmax} are set as the m/z and RT
range for loading.}

\item{mzAdd}{The extra m/z range for loading (both sides), and the default is
0.005.}

\item{rtAdd}{The extra RT range for loading (both sides), and the default is
10 (seconds).}

\item{profstep}{The size of each m/z bin for peak integration, and the
default is 0.}

\item{BPPARAM}{A object of \pkg{BiocParallel} to control parallel processing,
and can be created by
\code{\link[BiocParallel:SerialParam-class]{SerialParam}},
\code{\link[BiocParallel:MulticoreParam-class]{MulticoreParam}}, or
\code{\link[BiocParallel:SnowParam-class]{SnowParam}}.}
}
\value{
A list of the same length as the row number of \code{excluGroups}, in
which each element is a \code{\link{ncGTWinput}} object.
}
\description{
This function loads each raw sample profiles from the file with certain m/z
and RT range.
}
\details{
This function obtains the extracted ion chromatogram for each sample
at the givin m/z and RT range with a certain m/z bin size for integration.
Considering there may be missing peak by peak detection, \code{mzAdd} and
\code{rtAdd} are to increase the integration range.
}
\examples{
# obtain data
data('xcmsExamples')
xcmsLargeWin <- xcmsExamples$xcmsLargeWin
xcmsSmallWin <- xcmsExamples$xcmsSmallWin
ppm <- xcmsExamples$ppm

# detect misaligned features
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)

# obtain the paths of the sample files
filepath <- system.file("extdata", package = "ncGTW")
file <- list.files(filepath, pattern="mzxml", full.names=TRUE)

tempInd <- matrix(0, length(file), 1)
for (n in seq_along(file)){
    tempCha <- file[n]
    tempLen <- nchar(tempCha)
    tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
        tempLen - 6))
}
# sort the paths by data acquisition order
file <- file[sort.int(tempInd, index.return = TRUE)$ix]

# load the sample profiles
ncGTWinputs <- loadProfile(file, excluGroups)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ncGTWplot.R
\name{plotGroup}
\alias{plotGroup}
\title{Plot profiles for each peak group}
\usage{
plotGroup(ncGTWinput, sampleRt,
  sampleInd = seq_len(dim(ncGTWinput@rtRaw)[1]), ind = NULL,
  savePath = NULL, show = TRUE, sub = TRUE, filter = FALSE)
}
\arguments{
\item{ncGTWinput}{An object return by \code{\link{loadProfile}} of sample
profiles for plotting.}

\item{sampleRt}{A list of the same length as the sample number in which each
element is a vector corresponding to the sample raw/adjusted RT for
plotting.}

\item{sampleInd}{Indicate which samples should be plotted, and the default is
\code{1:dim(ncGTWinput$rtRaw)[1]}.}

\item{ind}{A user defined index, and the default is \code{NULL}.}

\item{savePath}{The path to save the plots, and the default is \code{NULL}
(do not save anything).}

\item{show}{Show the plot in R or not, and the default is \code{TRUE}.}

\item{sub}{Show more information on the plot or not, and the default is
\code{TRUE}.}

\item{filter}{Apply a Gaussian filter for demonstration or not, and the
default is \code{FALSE}.}
}
\value{
A plot to the current device.
}
\description{
This function plots sample profiles with loaded information.
}
\details{
This function plots the extracted ion chromatogram obtained by
\code{\link{loadProfile}}. The user can decide to save the figure, show the
figure, or apply a Gaussian filter on the data by parameter setting.
}
\examples{
# obtain data
data('xcmsExamples')
xcmsLargeWin <- xcmsExamples$xcmsLargeWin
xcmsSmallWin <- xcmsExamples$xcmsSmallWin
ppm <- xcmsExamples$ppm

# detect misaligned features
excluGroups <- misalignDetect(xcmsLargeWin, xcmsSmallWin, ppm)

# obtain the paths of the sample files
filepath <- system.file("extdata", package = "ncGTW")
file <- list.files(filepath, pattern="mzxml", full.names=TRUE)

tempInd <- matrix(0, length(file), 1)
for (n in seq_along(file)){
    tempCha <- file[n]
    tempLen <- nchar(tempCha)
    tempInd[n] <- as.numeric(substr(tempCha, regexpr("example", tempCha) + 7,
        tempLen - 6))
}
# sort the paths by data acquisition order
file <- file[sort.int(tempInd, index.return = TRUE)$ix]

# load the sample profiles
ncGTWinputs <- loadProfile(file, excluGroups)

# plot all loaded features
for (n in seq_along(ncGTWinputs))
    plotGroup(ncGTWinputs[[n]], slot(xcmsLargeWin, 'rt')$corrected)
}
